2024-01-14  Sergey Poznyakoff  <gray@gnu.org>

	Version 2.15

	Upgrade gnulib

	Upgrade copyright years

2023-05-23  Sergey Poznyakoff  <gray@gnu.org>

	Version 2.14.90

2023-05-18  Sergey Poznyakoff  <gray@gnu.org>

	Fix operation of --no-absolute-filenames --make-directories

	* src/copyin.c (symlink_placeholder): Try to create leading
	directories if unable to create placeholder.

2023-05-18  Sergey Poznyakoff  <gray@gnu.org>

	Upgrade paxutils

2023-05-17  Sergey Poznyakoff  <gray@gnu.org>

	Restore access and modification times of symlinks in copy-in
	and copy-pass modes.

	* gnulib.modules: Replace utimens with fdutimensat.
	* paxutils: Upgrade.
	* src/copyin.c: Update calls to set_file_times.
	(copyin_link,replace_symlink_placeholders): Call set_file_times
	if needed.
	* src/copyout.c: Update calls to set_file_times.
	* src/copypass.c (process_copy_pass): Update calls to
	set_file_times.
	Call set_file_times to restore times of extracted symlinks.
	* src/extern.h (set_file_times): Take additional argument.
	* src/util.c
	(set_file_times): Take additional argument.  Use fdutimensat to
	do the
	job.
	* tests/linktime.at: New file.
	* tests/linktime01.at: New file.
	* tests/Makefile.am: Add new files.
	* tests/testsuite.at: Include new tests.

2023-05-11  Sergey Poznyakoff  <gray@gnu.org>

	configure: Include needed header for major/minor macros

	This helps in avoiding the warning about implicit function
	declaration
	which is elevated as error with newer compilers e.g. clang 16

2023-05-01  Sergey Poznyakoff  <gray@gnu.org>

	Version 2.14

2023-04-29  Sergey Poznyakoff  <gray@gnu.org>

	Update NEWS

2023-04-28  Paul Eggert  <eggert@cs.ucla.edu>

	Use GNU ls algorithm for deciding timestamp format

	Problem reported by Dan Jacobson (Bug#50694).

	* gnulib.modules: Add gettime, timespec.
	* src/copyin.c: Include timespec.h.
	(current_time): Now struct timespec, not time_t.  All uses
	changed.
	(long_format): When formatting a timestamp, use the same
	algorithm that
	GNU ls does to decide whether a file is recent.

2023-04-28  Paul Eggert  <eggert@cs.ucla.edu>

	Fix integer overflows in timestamp output

	* src/copyin.c (long_format): Fix some unlikely integer overflow
	bugs.
	Work even if (current_time - when) overflows, which is
	possible if time_t is unsigned.
	Do not assume that system integer types fit into unsigned long.
	Simplify by using %ju.	No need for local tbuf array.

2023-04-28  Sergey Poznyakoff  <gray@gnu.org>

	Whitespace cleanup

	Update version of gnulib

2023-04-28  Sergey Poznyakoff  <gray@gnu.org>

	Fix appending to archives bigger than 2G

	* src/extern.h (last_header_start): Change type to off_t.
	* src/global.c: Likewise.
	* src/util.c (prepare_append): Use off_t for file offsets.

2023-04-28  Sergey Poznyakoff  <gray@gnu.org>

	Fix combination of --create, --append, --directory

	In copy-out mode, when appending, change_dir() would be called
	twice,
	because process_copy_in() calls change_dir().  If --directory=DIR
	was
	used with a relative path, this would result in incorrectly
	trying to
	change to DIR/DIR.  To fix this, change_dir() is only called
	explicitly when not appending.

	Patch by Alyssa Ross <hi@alyssa.is>

	* src/copyout.c (process_copy_out): Don't call change_dir if
	append_flag is set: it is going to be called by process_copy_in.

2023-04-28  Sergey Poznyakoff  <gray@gnu.org>

	New option --ignore-dirnlink

	Thus option is valid in copy-out mode.	It instructs cpio
	to always
	assume link count for directories to be 2.  It is implied by
	--reproducible.

	* NEWS: Document changes.
	* doc/cpio.1: Likewise.
	* doc/cpio.texi: Likewise.
	* src/copyout.c (process_copy_out): If ignore_dirnlink_option
	is set,
	assume c_nlink is 2.
	* src/extern.h (ignore_dirnlink_option): New extern.
	* src/global.c (ignore_dirnlink_option): New global.
	* src/main.c: New option --ignore-dirnlink.
	The option --reproducible implies --ignore-dirnlink.

2023-04-28  Sergey Poznyakoff  <gray@gnu.org>

	Fix 45b0ee2b407913c533f7ded8d6f8cbeec16ff6ca.

	The commit in question brought in more problems than solutions.
	To
	properly fix the issue, use symlink placeholders, modelled after
	delayed symlinks in tar.

	* src/copyin.c (symlink_placeholder)
	(replace_symlink_placeholders): New functions.
	(copyin_link): Create symlink placeholder if
	--no-absolute-filenames
	was given.
	(process_copy_in): Replace placeholders after extraction.
	* tests/CVE-2015-1197.at: Update. Don't use /tmp.

2023-04-27  Sergey Poznyakoff  <gray@gnu.org>

	Require automake 1.16.5

2023-04-27  Sergey Poznyakoff  <gray@gnu.org>

	Update for newer autotools

	* am/pack.m4: Don't use obsolete macros.
	* configure.ac: Likewise.
	Require autoconf 2.71
	* paxutils: Upgrade.
	* src/extern.h (STRINGIFY_BIGINT, UINTMAX_STRSIZE_BOUND):
	New definitions.
	(parse_user_spec): Change signature.
	* src/main.c: Update call to parse_user_spec.
	* src/idcache.c: Include extern.h
	* src/userspec.c: Likewise.

2023-04-07  Sergey Poznyakoff  <gray@gnu.org>

	Fix calculation of CRC in copy-out mode.

	* src/copyout.c (read_for_checksum): Fix type of the file_size
	argument.
	Rewrite the reading loop.

	Original patch by Stefano Babic <sbabic@denx.de>

2023-01-22  Sergey Poznyakoff  <gray@gnu.org>

	Upgrade gnulib

	Update copyright years

2022-02-13  Sergey Poznyakoff  <gray@gnu.org>

	Fix wording in the manpage

2022-01-02  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years

2021-09-03  Shreenidhi Shedi  <sshedi@vmware.com>

	Remove redundant condition check

	* src/util.c (tape_empty_output_buffer): Fix condition.

2021-09-03  Sergey Poznyakoff  <gray@gnu.org>

	Use inttostr to represent integer values as strings

	* gnulib.modules: Request inttostr
	* src/idcache.c (getuser,getgroup): Use umaxtostr instead
	of sprintf.
	* src/userspec.c (parse_user_spec): Likewise.

2021-08-18  Sergey Poznyakoff  <gray@gnu.org>

	Fix dynamic string reallocations

	* src/dstring.c (ds_resize): Take additional argument: number of
	bytes to leave available after ds_idx.	All uses changed.

2021-08-11  Sergey Poznyakoff  <gray@gnu.org>

	Fix previous commit

	* src/dstring.c (ds_reset,ds_concat): Don't call ds_resize in a
	loop.

2021-08-07  Sergey Poznyakoff  <gray@gnu.org>

	Rewrite dynamic string support.

	* src/dstring.c (ds_init): Take a single argument.
	(ds_free): New function.
	(ds_resize): Take a single argument.  Use x2nrealloc to expand
	the storage.
	(ds_reset,ds_append,ds_concat,ds_endswith): New function.
	(ds_fgetstr): Rewrite.	In particular, this fixes integer
	overflow.
	* src/dstring.h (dynamic_string): Keep both the allocated length
	(ds_size) and index of the next free byte in the string (ds_idx).
	(ds_init,ds_resize): Change signature.
	(ds_len): New macro.
	(ds_free,ds_reset,ds_append,ds_concat,ds_endswith): New protos.
	* src/copyin.c: Use new ds_ functions.
	* src/copyout.c: Likewise.
	* src/copypass.c: Likewise.
	* src/util.c: Likewise.

2021-03-24  Sergey Poznyakoff  <gray@gnu.org>

	Improve online version of the documentation.

2021-01-08  Sergey Poznyakoff  <gray@gnu.org>

	Update gnulib

	* NEWS: Raise version number.
	* configure.ac: Raise version number to 2.13.90.
	Raise autoconf and automake requirements.
	* gnulib: Pull v0.1-4336-gbdae9a5
	* gnulib.modules: Remove getopt
	* src/copyin.c (long_format): Cast rdev numbers to unsigned long

2021-01-06  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years

2020-09-18  Sergey Poznyakoff  <gray@gnu.org>

	Formatting changes in the documentation.

	* doc/cpio.1: Fix typos.
	* doc/cpio.texi: Consistently use proper Texinfo markup fo
	commands,
	files, and sample text fragments.

2020-02-08  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years

2020-01-20  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix * src/global.c: Remove superfluous declaration of
	program_name

2019-11-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix handling of device numbers (part 2)

	Previously the members of cpio_file_stat that hold device
	major and
	minor numbers were signed (long).  This caused issues when
	the device
	number was cast to unsigned value (uintmax_t) during a call to
	to_ascii or derived function.  In particular, on *BSD systems
	minor
	numbers are negative ints.  When such numbers are passed to
	to_ascii,
	the resulting unsigned representation does not fit into the target
	field width.  For details, see

	  https://lists.gnu.org/archive/html/bug-cpio/2019-11/msg00012.html

	To fix this, the return types are autodetected by configure.
	The types
	of the c_dev_maj, c_dev_min, c_rdev_maj, and c_rdev_min members of
	struct cpio_file_stat are changed to unsigned versions of the
	corresponding detected types.  This ensures that the value
	returned from
	major (or minor) will not undergo sign extension during assignment
	to the
	struct member and can be correctly promoted to a wider unsigned
	data
	type.

	* am/ax_compile_check_rettype.m4: New macro
	AC_COMPILE_CHECK_RETTYPE
	* configure.ac: Detect return types of major(3) and minor(3).
	* src/cpiohdr.h (cpio_file_stat): Change types of c_dev_maj,
	c_dev_min,
	c_rdev_maj, c_rdev_min.

2019-11-14  Sergey Poznyakoff  <gray@gnu.org>

	Fix handling of device numbers on copy out.

	Device minor and major numbers are meaningful only for devices.
	Don't attempt to store them for other files.  Instead fill the
	corresponding fields with zeros.

	* src/util.c (stat_to_cpio): Initialize c_rdev_maj  and c_rdev_min
	from struct stat only if the file is a device, otherwise set them
	to zero.

2019-11-08  Sergey Poznyakoff  <gray@gnu.org>

	Improve 684b7ac5

	* src/copyin.c (read_name_from_file): Handle len == 0.

2019-11-08  Sergey Poznyakoff  <gray@gnu.org>

	Fix cpio header verification.

	* src/copyin.c (read_name_from_file): Print error message and
	skip file if its name is not nul-terminated.

2019-11-06  Sergey Poznyakoff  <gray@gnu.org>

	Version 2.13

	* NEWS: Describe new version.
	* configure.ac: version 2.13
	* src/copyin.c: Fix strict aliasing violation.
	* tests/CVE-2019-14866.at: New file.
	* tests/Makefile.am: Add new test.
	* tests/testsuite.at: Add new test,

2019-11-04  Sergey Poznyakoff  <gray@gnu.org>

	Various fixes

	* doc/cpio.texi: Document URLs of the mailing list archive and
	subscription interface.
	* src/copyin.c (try_existing_file): Change type of the last
	argument.
	(copyin_file): Initialize existing_dir.
	* src/dstring.c: Include xalloc.h
	* src/filemode.c (mode_string): mode is unsigned int.

2019-11-04  Sergey Poznyakoff  <gray@gnu.org>

	Get rid of the unnecessary workaround.

2019-11-04  Sergey Poznyakoff  <gray@gnu.org>

	Don't repeat the help reference message.

	* src/main.c (process_args): Don't specify the "Try cpio --help"
	message explicitly. It is added automatically by the USAGE_ERROR
	macro.

2019-11-04  Sergey Poznyakoff  <gray@gnu.org>

	Fix CVE-2019-14866

	* src/copyout.c (to_ascii): Additional argument nul controls
	whether
	to add the terminating nul character.
	(field_width_error): Improve diagnostics: print the actual and the
	maximum allowed field value.
	* src/extern.h (to_ascii, field_width_error): New prototypes.
	* src/tar.c (to_oct): Remove.
	(to_oct_or_error): New function.
	(TO_OCT): New macro.
	(write_out_tar_header): Use TO_OCT and to_ascii. Return 0 on
	success, 1 on error.

2019-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Fix CVE-2015-1197

	* src/copyin.c (copyin_link): Force safer name suffix for
	symbolic links.
	* tests/CVE-2015-1197.at: New file.
	* tests/Makefile.am: Add new test case.
	* tests/testsuite.at: Likewise.

2019-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Provide functions for struct cpio_file_stat management.

	* src/copyin.c (long_format): Mark unchangeable argument as const.
	(read_name_from_file): Use cpio_realloc_c_name.
	(process_copy_in): Use CPIO_FILE_STAT_INITIALIZER.
	Call cpio_file_stat_free before return.
	* src/copyout.c (process_copy_out): Likewise.
	* src/copypass.c (link_to_name): Mark unchangeable argument
	as const.
	* src/cpiohdr.h (cpio_file_stat) <c_name_buflen>: New member,
	<c_tar_linkname>: Mark as const.
	(CPIO_FILE_STAT_INITIALIZER): New define.
	(cpio_file_stat_init,cpio_file_stat_free)
	(cpio_realloc_c_name): New protos.
	* src/extern.h: Fix prototypes.
	* src/makepath.c (make_path): Mark unchangeable argument as const.
	* src/util.c (create_all_directories): Mark unchangeable argument
	as const.
	(cpio_realloc_c_name): New function.
	(cpio_set_c_name): Use cpio_realloc_c_name.
	(cpio_file_stat_init,cpio_file_stat_free): New functions.

2019-11-03  Sergey Poznyakoff  <gray@gnu.org>

	Remove HPUX CDF support

2019-01-15  Sergey Poznyakoff  <gray@gnu.org>

	Minor fix in the testsuite

	* tests/symlink-long.at: Use m4 to create dirname, instead of
	using bash-specific syntax.

2018-12-01  Sergey Poznyakoff  <gray@gnu.org>

	Minor fixes

	* src/copyin.c: Remove unused variable.
	* src/util.c: Cast arguments to printf.

2018-12-01  Sergey Poznyakoff  <gray@gnu.org>

	Fix sigfault when appending to archive

	Bug reported by Ross Burton. See
	<http://lists.gnu.org/archive/html/bug-cpio/2018-11/msg00000.html>

	* src/util.c: Keep static copy of the buffer pointer; always
	assign it to file_hdr->c_name. Use x2realloc for memory
	management.

2018-06-21  Sergey Poznyakoff  <gray@gnu.org>

	Fix man markup

2017-04-14  Pavel Raiskup  <praiskup@redhat.com>

	CVE-2016-2037 - 1 byte out-of-bounds write

	Ensure that cpio_safer_name_suffix always works with dynamically
	allocated buffer, and that it has size of at least 32 bytes.
	Then, any call to cpio_safer_name_suffix is safe (it requires at
	least 2 bytes in the buffer).

	Also ensure that c_namesize is always correctly initialized (by
	cpio_set_c_name) to avoid undefined behavior when reading
	file_hdr.c_namesize (previously happened for tar archives).

	References:
	http://www.mail-archive.com/bug-cpio@gnu.org/msg00545.html

	* src/copyin.c (query_rename): Drop the hack, as we now work with
	dynamically allocated buffer.  Use cpio_set_c_name.
	(create_defered_links_to_skipped): Use cpio_set_c_name rather than
	manual assignment.
	(read_name_from_file): New function to avoid C&P.
	(read_in_old_ascii, read_in_new_ascii, read_in_binary): Use
	read_name_from_file.
	(process_copy_in): Initialize file_hdr.c_namesize.
	* src/copyout.c (process_copy_out): Use cpio_set_c_name.
	* src/cpiohdr.h (cpio_set_c_name): New prototype.
	* src/tar.c (read_in_tar_header): Use cpio_set_c_name.
	* src/util.c (cpio_set_c_name): New function to set
	file_hdr->c_name and c_namesize from arbitrary string.
	(cpio_safer_name_suffix): Some docs fixes.
	* tests/inout.at: Also test copy-in, and try various formats.

2017-02-06  Pavel Raiskup  <praiskup@redhat.com>

	build: lint warnings in --device-independent

	Complements: 3945f9db44c935608caa5f0

	* src/util.c (find_inode_val): Drop unused variable.
	(get_inode_and_dev): Function doesn't return any value, drop the
	return value in definition.

2017-01-02  Sergey Poznyakoff  <gray@gnu.org>

	Update copyright years

2016-11-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix the output of UTF8 file names in verbose mode.

	* am/quoting.m4: New file.
	* configure.ac: Set default quoting style.
	* src/copyin.c (long_format): Use quotearg.
	(print_name_with_quoting): Remove.
	* src/extern.h (print_name_with_quoting): Remove proto.

2016-11-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update docs

	* doc/cpio.texi: Prominently mention, that --absolute-file-names
	is
	the default.
	* doc/cpio.1: Likewise.

2016-11-10  Mike Frysinger  <vapier@gentoo.org>

	fix enable_mt configure logic

	In the default case, the build_mt flag is not set.  This leads
	to an
	error at configure time like:
	./configure: line 26866: test: =: unary operator expected

	Change to use the variable name autoconf creates for us and
	quote it
	so we never get weird expansion errors.

2016-11-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update the THANKS file.

2016-11-10  grajagandev  <dmoorefo@gmail.com>

	Fix signed integer overflow - big block sizes

	Add test for signed integer overflow

2016-11-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix out-of-bounds read

	* src/copyin.c (process_copy_in): Skip records with zero filename
	length.

2016-06-16  Pavel Raiskup  <praiskup@redhat.com>

	bootstrap: fix bootstrap after clean clone

	* bootstrap.conf: Reintroduce changes added by
	c7e60954dc7945635194 and removed by cleanup in
	0396591026410f9.
	* lib/Makefile.am: Honor the ^pax prefix.
	* po/POTFILES.in: Likewise.

2015-09-12  Sergey Poznyakoff  <gray@gnu.org>

	Version 2.12

	Update docs, use gettext 0.19.6

2015-09-01  Sergey Poznyakoff  <gray@gnu.org>

	Fix generation of manual directory

	* doc/Makefile.am: Change 'manual' goal.
	* doc/gendocs.sh: New file.
	* doc/gendocs_template: ps output is not built.

2015-09-01  Sergey Poznyakoff  <gray@gnu.org>

	Remove not used files

	* headers/Makefile.am: Remove.
	* headers/fnmatch.h: Remove.
	* Makefile.am: Update.
	* configure.ac: Update.

2015-09-01  Sergey Poznyakoff  <gray@gnu.org>

	Include gnulib and paxutils as submodules.

	* gnulib: New submodule.
	* paxutils: New submodule.
	* .gitignore: Updage
	* .gitmodules: Update
	* README-hacking: Update.
	* bootstrap: Install slightly modified version from the gnulib
	repo.
	* bootstrap.conf: Add paxutils-related stuff.
	* po/.gitignore: Update.
	* tests/symlink-bad-length.at: Fix expected output.
	* src/copyin.c: Tiny change.
	* src/util.c: Likewise.

2014-12-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix symlink-bad-length test for 64-bit architectures.

	* src/util.c: Return non-zero exit code if EOF is hit prematurely.
	* tests/symlink-bad-length.at: Revert to original archive: there's
	no use testing for recovery, because that depends on the host
	architecture.  Don't test for exit code as well (same reason).
	Account for eventual warning messages.

2014-12-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix error recovery in copy-in mode

	* src/copyin.c (copyin_link): Fix null dereference.
	(read_in_header): Fix error recovery (bug introduced by
	27e0ae55).
	* tests/symlink-bad-length.at: Test error recovery.
	Catch various architecture-dependent error messages (suggested
	by Pavel Raiskup).

2014-12-02  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix typo

2014-12-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfix

	* src/copyin.c (get_link_name): Fix range checking.
	* tests/symlink-bad-length.at: Change expected error message.

2014-12-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix memory overrun on reading improperly created link records.

	See
	http://lists.gnu.org/archive/html/bug-cpio/2014-11/msg00007.html

	* src/copyin.c (get_link_name): New function.
	(list_file, copyin_link): use get_link_name

	* tests/symlink-bad-length.at: New file.
	* tests/symlink-long.at: New file.
	* tests/Makefile.am: Add new files.
	* tests/testsuite.at: Likewise.

2014-12-01  Sergey Poznyakoff  <gray@gnu.org.ua>

	New options to create device and inode-independent archives.

	* src/util.c (inode_val): New member trans_inode
	(find_inode_val): New function.
	(find_inode_file): Rewrite using the above.
	(add_inode): Initialize the trans_inode member
	depending on the value of renumber_inodes_option.
	(get_inode_and_dev): New function.
	(stat_to_cpio): Use get_inode_and_dev.
	(arf_stores_inode_p): New function.
	* src/extern.h (renumber_inodes_option)
	(ignore_devno_option): New externs.
	* src/global.c (renumber_inodes_option)
	(ignore_devno_option): New variables.
	* src/main.c: Add new options.

	* NEWS: Document changes.
	* doc/cpio.1: Document new options.
	* doc/cpio.texi: Likewise.

2014-01-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix package name recognition in bootstrap.

	The script logic failed if AC_INIT was split among two lines.
	Reported
	by Pavel.

	* bootstrap (extract_package_name): Rewrite as m4 script to allow
	for multiline AC_INIT.

2014-01-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update copyright years.

2014-01-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	Treat UID/GID as numeric if prefixed by + (-R option)

	The IDs supplied with the -R option are treated as numeric
	(without
	looking them up in the system database), when prefixed with +.
	This
	allows to force using numeric value if a user (group) with
	a numeric
	name exists in the database.

	Reported by Joshua Briefman <sirgatez@gmail.com>.

	* src/userspec.c (parse_user_spec): Use + as an indicator of
	a numeric UID/GID.
	* doc/cpio.1: Document changes.
	* doc/cpio.texi: Likewise.

2014-01-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	Use exit codes consistenly.

2014-01-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve documentation.

	* .gitignore: Update.
	* NEWS: Update.
	* doc/cpio.1: Rewrite.
	* doc/cpio.texi: Major revamp.
	* src/main.c (options): Fix sectioning of the help output.
	(parse_opt):
	* src/util.c: Use PAXEXIT_FAILURE to indicate an error.

2014-01-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	Distribute rmt.8; update build system

	* NEWS: Update.
	* bootstrap (gnulib_extra_files): Remove "missing"
	* configure.ac: Do not distribute shar archive.
	Define CPIO_MT_COND
	* doc/Makefile.am: Always install manpages (mt.1 and rmt.8 --
	depending on whether the corresponding programs are built).
	* doc/cpio.1: Update.
	* doc/mt.1: Update.
	* lib/Makefile.am: Use AM_CPPFLAGS instead of INCLUDES.
	* src/Makefile.am: Likewise.
	* tests/Makefile.am: Likewise.

2012-02-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	Always use 32 bit CRC

	* src/cpiohdr.h (cpio_file_stat) <c_chksum>: Change type to
	uint32_t.
	* src/extern.h (crc): Change type to uint32_t.
	* src/global.c: Likewise.
	* src/copyout.c (read_for_checksum): Return uint32_t.
	* src/copyin.c: Fix printf formats.

2011-09-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix error handling in disk_empty_output_buffer and sparse_write

	* src/extern.h (delayed_seek_count): Remove.
	(disk_empty_output_buffer): Change signature.
	* src/util.c (disk_empty_output_buffer): Take two arguments.
	Correctly handle partial writes (errno is not meaningful).
	(delayed_seek_count): Remove variable.
	(sparse_write): Change return type and signature.  Rewrite.
	Return number actual number of bytes written or -1 on error.
	Check returns from lseek and write.
	* src/copyin.c (copyin_regular_file): Call
	disk_empty_output_buffer
	with flush=true before closing the file.
	* src/copypass.c (process_copy_pass): Likewise.

2011-09-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes.

	* configure.ac: Use gettext 0.18
	* doc/.gitignore: Add parse-datetime.texi.
	* lib/Makefile.am (libpax_a_SOURCES): Add exit-status.c
	* src/copyin.c (read_pattern_file): Use open_fatal if opening
	pattern file failed.
	* src/util.c (set_file_times): Use fdutimens.

2010-08-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfixes.

	* gnulib.modules: Add getline, required by rmt.
	* src/mt.c (fatal_exit): Change exit code to
	MT_EXIT_FAILURE.

2010-07-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix setstat testcases to work on Darwin.

	* tests/setstat01.at: Set write permission on the directory
	before attempting to rename it.
	* tests/setstat02.at: Likewise.

2010-07-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	Housekeeping.

	* .gitignore: Sort.
	* src/cpiohdr.h: Fix indentation of preprocessor statements.
	* src/filetypes.h: Likewise.

2010-07-23  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve handling of -D in copy-pass mode.

	* gnulib.modules: Add xgetcwd.
	* src/copypass.c (process_copy_pass): Convert directory_name
	to absolute if -D option was given.

2010-07-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix bootstrapping.

	* bootstrap (symlink_to_dir): Fix symlink calculation.

2010-07-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fix.

	* src/filetypes.h: Remove declarations of stat and lstat.

2010-07-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor fixes.

	* src/copyout.c (count_defered_links_to_dev_ino): Return size_t.
	(last_link): Do not use superfluous local variable.
	* src/util.c (copy_files_disk_to_tape)
	(copy_files_disk_to_disk): Shut down gcc warnings.

2010-07-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor changes

	* .gitignore: Update.
	* am/.gitignore: New file.
	* src/.gitignore: Add .gdbinit.
	* tests/symlink-to-stdout.at: Fix keywords.

2010-07-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Provide a tar-like --directory (-D) option.

	* src/copyin.c (process_copy_in): Call change_dir.
	* src/copyout.c (process_copy_out): Likewise.
	* src/copypass.c (process_copy_pass): Likewise.
	* src/extern.h (change_directory_option): New extern.
	(change_dir): New proto.
	* src/global.c (change_directory_option): New global.
	* src/main.c (options): New option --directory.
	(parse_opt): Handle the --directory option.
	* src/util.c (change_dir): New proto.

	* doc/cpio.texi: Document the --directory option.

2010-07-22  Dmitry V. Levin  <ldv@altlinux.org>

	Fix --to-stdout option support

	* src/copyin.c (copyin_link): Skip an appropriate number of bytes
	when to_stdout_option flag is set.
	* tests/symlink-to-stdout.at: New test case.
	* tests/Makefile.am (TESTSUITE_AT): Add symlink-to-stdout.at.
	* tests/testsuite.at: Include symlink-to-stdout.at.

2010-03-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 2.11

	* configure.ac, NEWS: Raise version number.

2010-03-10  Sergey Poznyakoff  <gray@gnu.org.ua>

	Bugfixes.

	* src/main.c (cpio_options): Remove unused options.
	* src/util.c (cpio_create_dir): Fix conditional.
	* NEWS: Update.

2010-02-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	Use same code when creating directories in copy-in and copy-pass
	modes.

	* src/copyin.c (copyin_mkdir): Remove.
	(copyin_directory): Remove.
	(copyin_file): Use cpio_create_dir instead
	of copyin_directory.
	* src/copypass.c (process_copy_pass): Use cpio_create_dir
	to create directories.
	* src/extern.h (delay_cpio_set_stat): New proto.
	* src/util.c (delay_cpio_set_stat): New function.
	(delay_set_stat): Rewrite as a wrapper to the above.
	(cpio_create_dir): New function.
	* tests/setstat01.at: Fix testcase.
	* tests/setstat02.at: Likewise.
	* tests/setstat03.at: New testcase.
	* tests/setstat04.at: New testcase.
	* tests/setstat05.at: New testcase.
	* tests/Makefile.am: Add new testcases.
	* tests/testsuite.at: Likewise.

2010-02-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix inode number typing.

	* src/copyin.c (create_defered_links): Use ino_t for
	inode numbers.
	(create_defered_links_to_skipped): Likewise.
	(process_copy_in): Add typecast to inode fprintf argument.
	* src/copyout.c (count_defered_links_to_dev_ino)
	(writeout_other_defers): Use ino_t for inode numbers.
	* src/copypass.c (link_to_maj_min_ino): Likewise.
	* src/util.c (struct inode_val): Likewise.
	(find_inode_file, add_inode): Likewise.
	* src/extern.h (link_to_maj_min_ino)
	(find_inode_file, add_inode): Change signature.

2010-02-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Improve configuration suite.

	* configure.ac: Raise version number to 2.10.91.
	Require autotools 2.63/1.11.1.
	Create shar archive.
	Enable silent rules by default.
	* Makefile.am (AUTOMAKE_OPTIONS): Remove.
	* lib/Makefile.am (rmt-command.h): Silent rule.
	* NEWS: Update.

2010-02-11  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update copyright years.

2009-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	Delay setting directory attributes until end of run, if they do
	not permit writing. Fix debian bug #458079.

	* src/copyin.c (copyin_mkdir): New function.
	(copyin_directory): Use copyin_mkdir to create directory.
	Call set_perms only when safe, otherwise use
	repair_delayed_set_stat.
	* src/extern.h (cpio_to_stat): New prototype.
	(repair_delayed_set_stat): Change prototype.
	* src/util.c (cpio_to_stat): New function.
	(repair_delayed_set_stat): New function.
	* tests/setstat01.at: New test case.
	* tests/setstat02.at: New test case.
	* tests/Makefile.am (TESTSUITE_AT): Add setstat01.at and
	setstat02.at
	* tests/testsuite.at: Include setstat01.at and setstat02.at.

	* NEWS: Update.

2009-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	Minor compatibility fix

	* src/cpiohdr.h (struct old_cpio_header): c_dev and c_rdev
	are unsigned short.

2009-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	Raise version number to 2.10.90

2009-07-31  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix mt and make sure it is always build during distcheck. Minor
	fixes in cpio.

	* Makefile.am (AM_DISTCHECK_CONFIGURE_FLAGS): New variable.
	Ensure that distcheck builds mt.
	* bootstrap: Patch Makefile.in to honor
	AM_DISTCHECK_CONFIGURE_FLAGS.
	* gnulib.modules: add argp-version-etc and progname.
	* src/Makefile.am: Remove useless dependency.
	* src/copyin.c (long_format): Fix printf arguments.
	* src/copyout.c (read_for_checksum): Return unsigned long.
	(process_copy_out): Remove unused variable.
	* src/extern.h (crc): Change type to unsigned long.
	(program_name): Remove.
	* src/global.c: Likewise.
	* src/main.c: Include argp-version-etc.h and progname.h
	(argp_program_version): Remove.
	(program_authors): New global.
	(options): Remove the 'Informative options' group. These are
	handled automatically by argp.
	(parse_opt): Likewise.
	(licence): Remove. This info is output by --version.
	(process_args): Remove useless test.
	(main): Use set_program_name and argp_version_setup.

	* src/mt.c: Remove superfluous includes.
	Include argp-version-etc.h and progname.h
	Use argp to parse arguments.
	Supply the fatal_exit function.

	* tests/version.at: Update for the new --version output.

	* THANKS: Add Peter Breitenlohner.
	* AUTHORS: Update Sergey's email.

2009-06-22  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix bootstrap

	* bootstrap: do not modify original system.h, create a copy of
	it instead.

2009-06-20  Sergey Poznyakoff  <gray@gnu.org.ua>

	Version 2.10

2009-06-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Update docs.

	* NEWS, THANKS: Update

2009-06-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Make sure the structs used for I/O mapping are not padded.

	* am/flushleft.m4, am/pack.m4: New files.
	* Makefile.am (ACLOCAL_AMFLAGS): Add -I am.
	* bootstrap: Fix arguments to aclocal.
	* configure.ac: Call CPIO_PACKED_STRUCTS.
	* src/cpiohdr.h: Ensure old_cpio_header,
	old_ascii_header and new_ascii_header are packed.

2009-06-19  Clint Adams  <schizo@debian.org>

	Improve docs

	* doc/cpio.texi: Document format file size limits.

2009-06-19  Sergey Poznyakoff  <gray@gnu.org.ua>

	Housekeeping changes

	* lib/Makefile.am: New file
	* src/Makefile.am (INCLUDES): add lib
	* src/main.c: Include configmake.h (needed for LOCALEDIR).
	* tests/Makefile.am (check-local, installcheck-local): Honor
	TESTSUITEFLAGS.

2009-03-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	Refelect changes to paxutils

2009-02-14  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix exit codes

	Minor fix

	Fix bootstrap

	Delete paxutils

	Switch to Git

2008-03-06  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Update .cvsignore files.
	* po/.cvsignore: Update.

	* bootstrap: Sync with tar.
	* po/.cvsignore: New file.

2008-02-09  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS, configure.ac: Raise the patchlevel number.
	* THANKS: Update
	
	* doc/cpio.texi: Fix a typo.
	* src/extern.h (warn_if_file_changed): Fix type of the 2nd
	argument.
	* src/tar.c (write_out_tar_header): Stylistic change.
	* src/util.c (copy_files_disk_to_disk): Fix types of automatic
	variables. 
	(warn_if_file_changed): Fix type of the 2nd argument.
	
	Patches supplied by Ladislav Michnovic.
	
2008-02-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* po/POTFILES.in: Add missing files.
	* src/Makefile.am (INCLUDES): Add -I$(top_builddir)/lxib
	* src/extern.h (warn_if_file_changed): Fix type of the 3rd
	argument.
	* src/util.c (copy_files_tape_to_disk)
	(copy_files_disk_to_tape): Fix types of size and k.
	(warn_if_file_changed): Fix type of the 3rd argument.

2007-12-05  Sergey Poznyakoff  <gray@gnu.org.ua>

	Fix mingw build. Thanks to Robert Millan.
	
	* NEWS, THANKS: Update.
	* bootstrap: Create lib/system.c, m4/sysdep.m4, update lib/system.h.
	* mingw.m4, sysdep.m4: New files.
	* configure.ac: Raise version number to 2.9.90.
	Call CPIO_SYSDEP. Remove the call to gl_USE_SYSTEM_EXTENSIONS.
	(AC_CHECK_HEADERS): Add process.h sys/ioctl.h
	* lib/Makefile.am (libcpio_a_SOURCES): Add system.c
	* src/idcache.c: Include system.h
	* src/userspec.c: Remove alloca stuff (already handled by
	gnulib). Include alloca.h.
	Remove useless declarations of get.* functions.
	* src/util.c: Include sys/ioctl.h conditionally.

2007-09-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/copyin.c (read_in_binary): Fix passing improper argument
	to swab_array. Reported by Dr. David Alan Gilbert.

2007-06-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Update for the change of the TP URL
	
	* NEWS: Update
	* src/extern.h, src/makepath.c (make_path): Remove mode
	argument. All callers updated.
	* src/util.c (apply_delayed_set_stat): Use inverted permissions
	from data->stat.
	* tests/interdir.at: New test case.
	* tests/Makefile.am, tests/testsuite.at: Add interdir.at

	* src/copyin.c, src/copypass.c: Save current umask before
	processing and call apply_delayed_set_stat afterwards
	* src/extern.h (newdir_umask): New global
	(delay_set_stat,repair_delayed_set_stat)
	(apply_delayed_set_stat): New functions
	
	* src/global.c (newdir_umask): New global
	* src/idcache.c: Include xalloc.h
	* src/main.c: New warning control option -W interdir
	* src/makepath.c: Rewrite using delayed set_stat functions
	* src/util.c (create_all_directories): Update call to make_path
	(delay_set_stat,repair_delayed_set_stat)
	(apply_delayed_set_stat): New functions

	* NEWS, doc/cpio.1, doc/cpio.texi: Update
	* src/copyin.c, src/copyout.c, src/copypass.c: Number of blocks is
	size_t.
	* src/extern.h, src/global.c: Use size_t for buffer sizes and
	off_t for total I/O bytes.

2007-06-27  Sergey Poznyakoff  <gray@gnu.org.ua>

        Relicense under GPLv3

2007-06-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Version number 2.8
	* bootstrap.conf: Update

2007-06-07  Sergey Poznyakoff  <gray@gnu.org.ua>

	* NEWS: Update
	* configure.ac: Raise version to 2.7.90
	* doc/cpio.texi: Update
	* src/extern.h (set_perms, set_file_times): Take file descriptor
	as the first argument.
	* src/util.c (set_perms): Take file descriptor
	as the first argument and use fchmod/fchown if available.  Fixes
	CAN-2005-1111.
	* src/copyin.c, src/copyout.c, src/copypass.c: Update calls to
	set_perms.
	* src/makepath.c: Remove useless includes.
	
	* src/util.c (set_perms, stat_to_cpio): Use CPIO_UID and CPIO_GID
	macros to set uid and gid
	* src/main.c (process_args): Allow to use --owner in copy-out mode.
	* THANKS: Add Mike Frysinger
	
2007-05-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Update from tar repository
	* doc/cpio.texi: Fix typo
	* src/copyin.c (from_ascii): Bugfix: allow for empty fields
	* src/copyout.c (process_copy_out): Fix memory leaks on
	orig_file_name.
	* src/copypass.c (process_copy_pass): symlink_error takes two
	arguments.
	* src/extern.h: Add missing includes.

2006-12-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* README-cvs: New file
	* lib/Makefile.tmpl, lib/bcopy.c, lib/mkdir.c, lib/strdup.c,
	lib/strerror.c, lib/.cvsignore, po/.cvsignore,
	po/Makevars: Removed
	* lib/Makefile.am: New file
	* po/POTFILES.in: Update
	* bootstrap: Synch with tar.
	* configure.ac: Update
	* gnulib.modules: Add lchown, strerror
	* src/Makefile.am: Update
	* src/main.c, src/mt.c: Include rmt-command.h instead of localedir.h
	* .cvsignore, doc/.cvsignore: Sort
	
	* src/util.c (sparse_write): Static.  Provide a forward
	declaration. Define enum sparse_write_states inside the function.

	* src/copyin.c (long_format): Use PRIuMAX for printing file size
	* src/copyout.c (write_out_binary_header): Fix size conversion
	* src/extern.h (tape_toss_input, warn_if_file_changed): Last
	argument is off_t
	* src/util.c (tape_toss_input, warn_if_file_changed): Last
	argument is off_t
	(warn_if_file_changed): Use ngettext

2006-11-15  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/copypass.c: Fix setting output file permissions

2006-11-13  Sergey Poznyakoff  <gray@gnu.org.ua>

	* doc/cpio.texi: Consistently use @option{} for displaying command
	line options.
	Fix formatting in "Invoking `cpio'" section
	* src/main.c (process_args): Fix usage error diagnostics in
	copy-pass mode.

2006-10-24  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/copyout.c (process_copy_out): Add terminating zero to the
	link_name.

	* tests/symlink.at: New testcase
	* tests/Makefile.am: New test symlink.at
	* tests/inout.at: Add keywords
	* tests/testsuite.at (AT_SKIP_TEST): New macro
	New test symlink.at

2006-10-21  Sergey Poznyakoff  <gray@gnu.org.ua>

	* configure.ac, NEWS: Version 2.7
	* gnulib.modules: Add stdint
	* src/util.c: Use STRINGIFY_BIGINT to display num_bytes

2006-09-27  Sergey Poznyakoff  <gray@gnu.org.ua>

	* TODO: Update
	* README-alpha: Update
	* bootstrap: Imported from tar
	* configure.ac: Require autoconf 2.59 and gettext 1.15
	* gnulib.modules: add inttypes
	* doc/cpio.texi: Minor fixes
	* po/Makevars: Remove automatically generated file
	* po/.cvsignore: Add Makevars
	* lib/.cvsignore: Update
	* src/copyin.c, src/copyout.c, src/copypass.c, src/cpio.h,
	src/cpiohdr.h, src/defer.c, src/defer.h, src/extern.h,
	src/global.c, src/main.c, src/makepath.c, src/tar.c,
	src/util.c: Update copyright year. 

2006-07-04  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap (update_po): Fix single translation update
	* lib/Makefile.tmpl: Initialize AM_CPPFLAGS
	(noinst_HEADERS): Add system-ioctl.h

	Start rewriting using a better suited internal representation for
	the file meta-data.
	
	* src/cpiohdr.h (struct old_cpio_header): Remove unused fields
	c_mtime, c_filesize and c_name.
	(struct old_ascii_header): New data type
	(struct new_ascii_header): New data type. Describes the header
	structure, not its internal representation.
	(struct cpio_file_stat): New data type. Describes internal
	representation of a file metadata

	* src/copyin.c (from_ascii): New function
	Use cpio_file_stat for internal header representation.
	* src/copyout.c: Use cpio_file_stat for internal header
	representation. Among other things this fixes bug reported by
	Peter Vrabec on Mar 2, 2006
	(http://lists.gnu.org/archive/html/bug-cpio/2006-03/msg00000.html)
	* src/copypass.c: Use cpio_file_stat for internal header
	representation.
	* src/tar.c: Likewise
	* src/util.c: Likewise
	* src/defer.c: Likewise
	* src/defer.h: Likewise
	* src/extern.h: Likewise
	(from_ascii): New prototype
	(LG_8,LG_16,FROM_OCTAL,FROM_HEX): New defines
	* src/main.c: New command line option --HANG (hidden)

2006-03-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* tests/Makefile.am (AM_CPPFLAGS): Define LOCALEDIR

2006-02-18  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Add stpcpy. Thanks Benigno B. Junior for
	reporting.
	* THANKS: Add Benigno B. Junior
	* src/makepath.c: Fix indentation.

2005-11-16  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/copyout.c (process_copy_out): Fix typo.

2005-11-12  Sergey Poznyakoff  <gray@gnu.org.ua>

	* bootstrap: Minor fix
	* src/copyout.c (write_out_header): Rewritten using separate
	functions for each file format. Use to_ascii to convert numbers to
	ascii representation. Check for overflows and report them if
	appropriate. Return 0 if it is OK to proceed with archiving this
	file, 1 otherwise. All callers updated.
	* src/extern.h (write_out_header): Return int.

2005-10-28  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/util.c: Include paxlib.
	* bootstrap: If file `.bootstrap' exists in the cwd and is
        readable, prepend its contents to the command line.

	Fix Debian bug 335580:
	
	* src/copyout.c (read_for_checksum,write_out_header): CRC is a
	32-bit unsigned value. Patch proposed by Jim Castleberry and
	Peter Vrabec. 
	* src/extern.h (crc): Change declaration
	* src/global.c: Likewise
	* src/tar.c (tar_checksum): Return unsigned int

	* THANKS: Add Jim Castleberry
	* NEWS: Updated
	
2005-09-30  Sergey Poznyakoff  <gray@gnu.org.ua>

	* src/copyout.c (process_copy_out): Discern between original and
	(eventually fixed) file name (in tar terminology, `file name'
	vs. `member name'.

2005-09-08  Sergey Poznyakoff  <gray@gnu.org.ua>

	* gnulib.modules: Add utimens
	* src/util.c (cpio_safer_name_suffix): Preserve ./ no matter what
	the value of strip_leading_dots is.
	(set_file_times): New function
	* src/extern.h (set_file_times): New function
	* src/copyin.c: Use set_file_times() to update file atime/mtime
	* src/copyout.c: Likewise.
	* src/copypass.c: Likewise.

2005-05-25  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/copyin.c: Use cpio_safer_name_suffix() and CPIO_TRAILER_NAME
	define instead of hardcoding the trailer file name.
	* src/copyout.c: Likewise.
	* src/cpio.h (CPIO_TRAILER_NAME): New define
	* src/extern.h (cpio_safer_name_suffix): New proto
	* src/tar.c: Use CPIO_TRAILER_NAME define instead of hardcoding
	the trailer file name.
	* src/util.c (cpio_safer_name_suffix): New function
	(add_cdf_double_slashes): Add FIXME warning.
	
	* lib/fatal.c: New file
	* lib/Makefile.tmpl (libcpio_a_SOURCES): Add fatal.c
	* src/copyout.c: Use error reporting functions from paxlib
	* src/makepath.c: Likewise
	* src/mt.c: Likewise
	* src/main.c (fatal_exit): Moved to lib/fatal.c

2005-05-24  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/copyin.c (process_copy_in): Use safer_name_suffix no matter
	what the value of no_abs_paths_flag. The function knows better
	what to do in any case.
	* src/copyout.c (process_copy_out): Honor no_abs_paths_flag.
	* src/main.c (options): Minor fixes.

2005-05-23  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap (copy_files): Create destination directory if it does
	not exist.
	Preserve longlong.m4 as longlong_gl.m4 
	* src/main.c: Include paxlib.h
	
2005-05-22  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* lib/.cvsignore: Updated
	* gnulib.modules: Add hash
	* doc/cpio.texi (Reports): New chapter
	* lib/Makefile.tmpl: Add new paxutils files.
	* po/POTFILES.in: Likewise
	* src/copyin.c [!HAVE_LCHOWN] (lchown): Define to 0 to avoid
	changing ownership of the target file.
	(process_copy_in): Use safer_name_suffix()
	* src/main.c (parse_opt): Handle new --absolute-filenames option.
	(process_args): Updated
	* src/util.c: Rewrite inode lookup/insertion functions using hash
	module. 

u2005-05-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Raised version number to 2.6.90
	* NEWS: Updated
	* src/copyin.c: Use set_perms.
	* src/copypass.c: Likewise.
	* src/copyout.c (process_copy_out): Use stat_to_cpio() to convert
	struct stat to struct new_cpio_header.
	* src/defer.h: Remove legacy P_() stuff.
	* src/dstring.c: Likewise
	* src/extern.h: Likewise
	* src/util.c (stat_to_cpio,set_perms): New functions
	* doc/.cvsignore: Updated
	* lib/.cvsignore: Updated
	* tests/.cvsignore: Updated
	* .cvsignore: Updated
	* COPYING: Added to the repository

2005-05-19  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* po/POTFILES.in: Add paxerror.c paxexit.c paxconvert.c

	* bootstrap (copy_files): Accept optional third argument: a prefix
	to be appended to destination file names.
	Import paxutils/paxlib files.
	* lib/Makefile.tmpl (libcpio_a_SOURCES): Add paxerror.c paxexit.c
	paxconvert.c
	* src/copyin.c: Use paxutils error reporting functions
	* src/copyout.c: Likewise
	* src/copypass.c: Likewise
	* src/util.c: Likewise. Add missing includes
	* src/main.c (USAGE_ERROR): Removed
	(CHECK_USAGE,parse_opt,process_args): Use error() instead of USAGE_ERROR
	(fatal_exit): New function
	* src/tar.c (is_tar_filename_too_long): Removed unused variable

	* Makefile.am, configure.ac, doc/Makefile.am,
	doc/cpio.texi, doc/gendocs_template, headers/Makefile.am,
	headers/fnmatch.h, lib/Makefile.tmpl, lib/mkdir.c,
	lib/strdup.c, lib/strerror.c, src/Makefile.am,
	src/copyin.c, src/copyout.c, src/copypass.c, src/cpio.h,
	src/cpiohdr.h, src/defer.c, src/defer.h, src/dstring.c,
	src/dstring.h, src/extern.h, src/filemode.c,
	src/filetypes.h, src/global.c, src/idcache.c,
	src/main.c, src/makepath.c, src/mt.c, src/tar.c,
	src/tar.h, src/tarhdr.h, src/userspec.c, src/util.c,
	tests/Makefile.am, tests/inout.at, tests/testsuite.at,
	tests/version.at: Updated FSF postal mail address.

	* bootstrap: Port recent changes from tar bootstrap.
	* gnulib.modules: New file
	* tests/Makefile.am (genfile_SOURCES,LDADD): Updated

	* THANKS: Updated
	* configure.ac: Remove check for gethostname, it is never used.
	Remove check for setsockopt, it is provided by paxutils.

	Fix LFS support issues. Proposed by Peter Vrabec and Dmitry V. Levin

	* src/extern.h (copy_files_tape_to_disk, copy_files_disk_to_tape,
	copy_files_disk_to_disk): Change num_bytes argument type from
	long to off_t.
	* src/util.c (copy_files_tape_to_disk, copy_files_disk_to_tape,
	copy_files_disk_to_disk, disk_fill_input_buffer,
	write_nuls_to_file): Likewise.
	(write_nuls_to_file, copy_files_disk_to_tape,
	copy_files_disk_to_disk): Handle `off_t num_bytes' properly.

	* src/util.c (find_inode_file): Fix typos causing function to
	occasionally miss inodes and, therefore, to copy out the same
	(hard-linked) file several times to archive. Proposed by Brian
	Mays.

2005-03-24  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/main.c (process_args): Fixed discrepancy I have been
	overlooking so far: cpio still does not handle --sparse option
	the same way tar is handling it. --sparse is allowed in copy-in
	and copy-pass modes, just as docs say it. Thanks Dmitry Levin.
	* THANKS: Updated

2005-03-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/util.c (disk_buffered_write): Fix typo introduced
	2005-01-11.
	* src/main.c (process_args): Fixed error message

2005-01-31  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/main.c (main): Remove umask(0). Fixes CAN-1999-1572.
	[__TURBOC__,__EMX__]: Removed
	* src/copypass.c (process_copy_pass): Set umask 0
	* src/copyin.c (process_copy_in): Likewise
	* src/util.c (open_archive): Use MODE_RW.
	
2005-01-11  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* doc/gendocs_template: Template file for gendocs.sh.
	* doc/Makefile.am: Use gendocs.sh to generate webdocs.
	* doc/cpio.texi: Updated.

	* src/copyin.c: Use memset instead of bzero, memmove
	(or memcpy, if appropriate), instead of bcopy, and
	strchr/strrchr instead of index/rindex.
	* src/copypass.c: Likewise.
	* src/main.c: Likewise.
	* src/makepath.c: Likewise.
	* src/tar.c: Likewise.
	* src/util.c: Likewise.
	(write_nuls_to_file): Made extern. All callers updated
	
	* src/copyout.c: Likewise. Use write_nuls_to_file instead
	of explicitely accessing zeros_512
	* src/userspec.c: Likewise.
	Rename isnumber to isnumber_p. Proposed by
	Albert Chin
	* src/extern.h (zeros_512): Removed
	(write_nuls_to_file): New function
	* src/global.c (zeros_512): Removed
	
2005-01-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* bootstrap: Add 'fileblocks' gnulib module
	Create paxutils.m4
	* configure.ac: Call cpio_PAXUTILS
	* src/main.c: Remove ifdef around setlocale
	* src/mt.c: Likewise

2004-12-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: New option --enable-mt
	Check for locale.h
	* doc/cpio.info: Removed
	* src/mt.c (main): Use argmatch_invalid()

2004-12-20  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Released version 2.6. Sources up to this point are tagged
	release_2_6.

	* configure.ac: Raised version number to 2.6
	* NEWS: Likewise
	* bootstrap (update_po): Give -r to wget. Always remove index.html
	Ignore alloca-opt module (it duplicates alloca)

2004-11-23  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/main.c (enum cpio_options): Bugfix: Initialize first enum
	value to 256.
	* bootstrap: Add unlocked-io
	* headers/argp.h: Removed
	* headers/getopt.h: Removed
	* headers/Makefile.am: Updated

2004-10-14  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/copyout.c: Add trailing slash to directory names in
	ustar format.
	* src/makepath.c: Removed redeclaration of error().
	* src/tar.c: Fixed deviations from POSIX.1-1988:
	Properly split long file names. Fill in octal fields with zeros,
	not spaces. Save only protection modes, not the whole mode.
	
	* NEWS: Updated

2004-09-08  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* NEWS: Updated
	* TODO: Updated
	* bootstrap: Install po files by default
	* po/LINGUAS: Removed. File is generated automatically
	* po/.cvsignore: Updated
	* src/copyin.c: Implemented --to-stdout option
	* src/copyout.c: Display the annoying 'truncating inode number'
	message only if the user wishes it.
	* src/extern.h: Added new globals.
	* src/global.c: Likewise.

	* src/main.c: Added support for --to-stdout and --warning options
	* src/tar.c (read_in_tar_header): Use warn_junk_bytes()
	* src/util.c (create_all_directories): Use dir_name.

	* configure.ac: Added support for the test suite
	* Makefile.am: Likewise

	* tests: New directory
	* tests/.cvsignore: New file
	* tests/Makefile.am: New file
	* tests/testsuite.at: New file
	* tests/inout.at: New file
	* tests/version.at: New file
	* tests/atlocal.in: New file
	
2004-09-07  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/main.c (process_args): Bugfix. Allow extra arguments
	in copy_in mode.
	* src/util.c (write_nuls_to_file): Use buffered I/O. All
	callers changed. Thanks Matthew Braithwaite <mab@cnet.com>
	for noticing.
	Bugfix: extra_bytes was mistakenly used instead of blocks.
	* THANKS: Added Matthew Braithwaite.

2004-09-06  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	Started merging with tar into paxutils. Sources before
	this point are tagged alpha-2_50_90.
	
	* bootstrap: New file
	* autogen.sh: Removed
	* Makefile.am: Updated
	* NEWS: Updated
	* README-alpha: Updated
	* configure.ac: Updated
	* doc/cpio.1: Updated
	* po/POTFILES.in: Updated

	* src/Makefile.am: Updated
	* src/error.c: Removed
	* src/dirname.c: Likewise
	* src/xmalloc.c: Likewise
	* src/stripslash.c: Likewise
	* src/xstrdup.c
	* src/gettext.h: Likewise
	* src/system.h: Likewise
	* src/rmt.h: Likewise
	* src/getopt.c: Likewise
	* src/getopt1.c: Likewise
	* src/bcopy.c: Likewise
	* src/fnmatch.c: Likewise
	* src/mkdir.c: Likewise
	* src/strdup.c: Likewise
	* src/argp-ba.c: Likewise
	* src/argp-eexst.c: Likewise
	* src/argp-fmtstream.c: Likewise
	* src/argp-fs-xinl.c: Likewise
	* src/argp-help.c: Likewise
	* src/argp-parse.c: Likewise
	* src/argp-pv.c: Likewise
	* src/argp-pvh.c: Likewise
	* src/argp-xinl.c: Likewise
	* src/pin.c: Likewise
	* src/alloca.c: Likewise
	* src/argmatch.c: Likewise
	* src/rmt.c: Likewise
	* src/rtapelib.c: Likewise
	* src/strerror.c: Likewise
	
	* src/copyin.c: Switched to ANSI C (sigh)
	* src/copyout.c: Likewise
	* src/copypass.c: Likewise
	* src/defer.c: Likewise
	* src/defer.h: Likewise
	* src/dstring.c: Likewise
	* src/dstring.h: Likewise
	* src/extern.h: Likewise
	* src/filemode.c: Likewise
	* src/global.c: Likewise
	* src/idcache.c: Likewise
	* src/main.c: Likewise
	* src/makepath.c: Likewise
	* src/mt.c: Likewise
	* src/tar.c: Likewise
	* src/userspec.c: Likewise
	* src/util.c: Likewise

	* lib: New directory
	* lib/Makefile.tmpl: New file
	* lib/bcopy.c: Moved from ../src
	* lib/mkdir.c: Likewise.
	* lib/strdup.c: Likewise.
	* lib/strerror.c: Likewise.
	
2004-08-30  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* Makefile.am: Added headers to SUBDIRS.
	* configure.ac: Check for AC_SYS_LARGEFILE.
	Use AC_CONFIG_LINKS to provide for fnmatch.h and getopt.h on
	the systems where these are missing
	Check for argp and replace it if necessary.
	* src/Makefile.am: Updated
	* src/fnmatch.h: Moved to headers/
	* src/getopt.h: Likewise.
	* src/main.c: Option parsing rewritten using argp. Improved
	option consistency checking.
	* src/rmt.c: Include getopt.h

	* src/argp-ba.c: New file
	* src/argp-eexst.c: New file
	* src/argp-fmtstream.c: New file
	* src/argp-fs-xinl.c: New file
	* src/argp-help.c: New file
	* src/argp-parse.c: New file
	* src/argp-pv.c: New file
	* src/argp-pvh.c: New file
	* src/argp-xinl.c: New file
	* src/pin.c: New file

	* headers: New directory
	* headers/Makefile.am: New file
	* headers/getopt.h: New file
	* headers/argp.h: New file
	* headers/fnmatch.h: New file
	* headers/.cvsignore: New file
	
2004-03-02  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/util.c (copy_files_disk_to_disk): Bugfix. If a file
	grew n bytes in copy-pass mode, these n bytes got prepended
	to the contents of all subsequent files. Fix provided by
	Holger Fleischmann <holger_fleischmann@mra.man.de>
	* THANKS: Added Holger Fleischmann.

2004-02-27  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* src/makepath.c: Remove unneded typedefs
	
	* src/copyin.c: Remove __MSDOS__ conditionals
	* src/copyout.c: Likewise
	* src/copypass.c: Likewise
	* src/main.c: Likewise
	* src/tar.c: Likewise
	* src/util.c: Likewise
	
2004-02-27  Sergey Poznyakoff  <gray@Mirddin.farlep.net>
	
	Changed from flat to deep package layout. Added the framework
	for NLS support.
	
	* .cvsignore: Updated
	* Makefile.am: Updated
	* configure.ac: Updated
	* NEWS: Updated
	* README-alpha: Updated
	* THANKS: Updated

	* autogen.sh: New file
	
	* alloca.c: Moved to src
	* argmatch.c: Likewise
	* bcopy.c: Likewise
	* dstring.h: Likewise
	* copyin.c: Likewise
	* copyout.c: Likewise
	* copypass.c: Likewise
	* cpio.h: Likewise
	* cpiohdr.h: Likewise
	* defer.c: Likewise
	* defer.h: Likewise
	* dirname.c: Likewise
	* dstring.c: Likewise
	* dstring.h: Likewise
        * error.c: Likewise
        * extern.h: Likewise
        * filemode.c: Likewise
        * filetypes.h: Likewise
        * fnmatch.c: Likewise
        * fnmatch.h: Likewise
        * getopt.c: Likewise
        * getopt.h: Likewise
        * getopt1.c: Likewise
        * global.c: Likewise
        * idcache.c: Likewise
        * main.c: Likewise
        * makepath.c: Likewise
        * mkdir.c: Likewise
        * mt.c: Likewise
        * rmt.c: Likewise
        * rmt.h: Likewise
        * rtapelib.c: Likewise
        * safe-stat.h: Likewise
        * strdup.c: Likewise
        * strerror.c: Likewise
        * stripslash.c: Likewise
        * system.h: Likewise
	* tar.c: Likewise
	* tar.h: Likewise
	* tarhdr.h: Likewise
	* userspec.c: Likewise
	* util.c: Likewise
	* xmalloc.c: Likewise
	* xstrdup.c: Likewise

 	* cpio.1: Moved to doc
	* cpio.texi: Likewise
        * mt.1: Likewise

	* src: New directory
        * src/.cvsignore: New file
        * src/Makefile.am: Likewise
        * src/alloca.c: Likewise
        * src/argmatch.c: Likewise
        * src/bcopy.c: Likewise
        * src/copyin.c: Likewise
        * src/copyout.c: Likewise
        * src/copypass.c: Likewise
        * src/cpio.h: Likewise
        * src/cpiohdr.h: Likewise
        * src/defer.c: Likewise
        * src/defer.h: Likewise
        * src/dirname.c: Likewise
        * src/dstring.c: Likewise
        * src/dstring.h: Likewise
        * src/error.c: Likewise
        * src/extern.h: Likewise
        * src/filemode.c: Likewise
        * src/filetypes.h: Likewise
        * src/fnmatch.c: Likewise
        * src/fnmatch.h: Likewise
        * src/getopt.c: Likewise
        * src/getopt.h: Likewise
        * src/getopt1.c: Likewise
        * src/gettext.h: Likewise
        * src/global.c: Likewise
        * src/idcache.c: Likewise
        * src/main.c: Likewise
        * src/makepath.c: Likewise
        * src/mkdir.c: Likewise
        * src/mt.c: Likewise
        * src/rmt.c: Likewise
        * src/rmt.h: Likewise
        * src/rtapelib.c: Likewise
        * src/safe-stat.h: Likewise
        * src/strdup.c: Likewise
        * src/strerror.c: Likewise
        * src/stripslash.c: Likewise
        * src/system.h: Likewise
        * src/tar.c: Likewise
        * src/tar.h: Likewise
        * src/tarhdr.h: Likewise
        * src/userspec.c: Likewise
        * src/util.c: Likewise
	* src/xmalloc.c: Likewise
	* src/xstrdup.c: Likewise

	* doc: New directory
	* doc/.cvsignore: New file
	* doc/Makefile.am: New file
	* doc/cpio.1: New file
	* doc/cpio.info: New file
	* doc/cpio.texi: New file
	* doc/mt.1: New file

	* po: New directory
	* po/.cvsignore: New file
	* po/LINGUAS: New file
	* po/Makevars: New file
	* po/POTFILES.in: New file
	
2003-11-28  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Added various checks
	* Makefile.am (rmt_LDADD): Added.
	* error.c: Updated
	* rmt.c: Removed useless private_errstring
	* system.h: Updated
	* userspec.c: Changed the way of handling declared vs. undeclared
	system calls.
	* strerror.c: New file. Borrowed from GNU Radius.

	* copyin.c: Removed kludgy declaration of delayed_seek_count.
	* copypass.c: Likewise
	* extern.h: Declare delayed_seek_count.
	* mkdir.c: Fixed handling of undeclared errno
	* mt.c: Likewise
	* util.c: Likewise
	* rtapelib.c: Likewise
	
2003-11-28  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* TODO: New file

	* README-alpha: New file
	* Makefile.am: Require at least version 1.7.1
	* configure.ac: Check for locale.h
	* main.c (main): Call setlocale. Thanks
	Mitsuru Chinen <mchinen@yamato.ibm.com>	for the patch.
	* THANKS: Updated
	
2003-11-21  Sergey Poznyakoff  <gray@Mirddin.farlep.net>

	* configure.ac: Added to the repository
	* Makefile.am: Likewise
	* NEWS: Likewise
	* README: Likewise
	* AUTHORS: Likewise
	* .cvsignore: Likewise
	
	* configure.in: Removed
	* Makefile.in: Removed
	* makefile.pc: Removed
	* configure: Removed
	
	* alloca.c: Added to the repository
	* argmatch.c: Likewise
	* bcopy.c: Likewise
	* cpio.h: Likewise
	* cpiohdr.h: Likewise
	* defer.c: Likewise
	* defer.h: Likewise
	* dirname.c: Likewise
	* dstring.c: Likewise
	* dstring.h: Likewise
	* error.c: Likewise
	* filemode.c: Likewise
	* filetypes.h: Likewise
	* fnmatch.c: Likewise
	* fnmatch.h: Likewise
	* getopt.c: Likewise
	* getopt.h: Likewise
	* getopt1.c: Likewise
	* idcache.c: Likewise
	* mkdir.c: Likewise
	* rmt.h: Likewise
	* rtapelib.c: Likewise
	* safe-stat.h: Likewise
	* strdup.c: Likewise
	* stripslash.c: Likewise
	* tar.c: Likewise
	* tar.h: Likewise
	* tarhdr.h: Likewise
	* xmalloc.c: Likewise
	* xstrdup.c: Likewise
	
	* makepath.c: Updated
	* mt.c: Likewise.
	* rmt.c: Likewise.
	* util.c: Likewise.
	* copyin.c: Likewise.
	* copyout.c: Likewise.
	* copypass.c: Likewise.
	* global.c: Likewise.
	* main.c: Likewise.
	
Thu Jun 13 20:14:48 2002  John Oleynick  (juo@gnu.org)
	* copyin.c:  Strip leading / on absolute filenames after
	comparing to the list of files specified on the command line
	(instead of before).  Problem reported by Jeff Holt.
	* Version 2.5 released.

Thu Jun 13 00:20:30 2002  John Oleynick  (juo@gnu.org)
	* Makefile.in:  Fixed problem of looking in srcdir for info files.
	Bug reported by Mike Castle.
	* cpio.texi:  Fixed typo.  Problem reported by Fabrice Bauzac.

Sun Jan 13 18:45:02 2002  John Oleynick  (juo@gnu.org)
	* copyin.c:  Fixed a problem skipping files with multiple links
	in a newc or CRC format archive.  If the file with the shared copy
	of the data was skipped, but other links were not skipped, the
	other links were created as empty files.  Bug reported by 
	Hendrik-Jan Thomassen.

Thu Dec  6 20:05:10 2001  John Oleynick  (juo@gnu.org)
	* mt.c, mt.1:  Merged Debian --rsh-command option and -V fix.
	* copyout.c, copypass.c, util.c, extern.h:  Modified to warn
	  if a file grows or its mtime is changed while it is being
	  copied.

Wed Dec  6 00:02:04 2001  John Oleynick  (juo@gnu.org)
	* Many files:  Updated FSF's address in copyright notices.

Wed Aug 29 23:57:05 2001  John Oleynick  (juo@gnu.org)
	* Many files:  Numerous fixes from Debian, Red Hat and SuSE
	GNU/Linux distributions.

Tue Jan 16 19:03:05 1996  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* util.c: An I/O error reading a file would cause the last byte
	of the next file to be corrupted in the archive.  Thanks to a
	buggy NT NFS server for pointing out this problem.
	* Version 2.4.2 released.

Tue Jan  9 23:19:37 1996  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* copyout.c: missed 1 part of last bug fix.

Mon Jan  8 16:49:01 1996  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* copyout.c, copypass.c: Use result of readlink() as length
	of link name instead of size from lstat().  On some OS's lstat() 
	doesn't return the true length in size.  Bug reported by
	Robert Joop (rj@rainbow.IN-berlin.DE).

Wed Dec 20 10:52:56 1995  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* rmt.c:  Added temporary kludge so make rmt will work on Linux.
	* configure.in:  Only define HAVE_UTIME_H if utime.h declares
	struct utimbuf.
	* Makefile.in:  Change prefix, exec_prefix and bindir to get their
	values from configure.  Added cpio.info to DISTFILES.
	* cpio.texi:  Added INFO-DIR-ENTRY.
	* Version 2.4.1 released.

Wed Nov 22 19:37:05 1995  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
        * cpio.texi:  Updated release date and FSF's address.
        * NEWS: Listed major new features for 2.4.
	* mt.c, mt.1: Added seek and fsfm commands.
	* Version 2.4 released.

Tue Jun 27 19:14:27 1995  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
        * configure.in: fixed for new autoconf.  Added check to make
	sure fnmatch() works.
        * Makefile.in: changed realclean to maintainer-clean.  Added
	support to handle fnmatch separate from other LIBOBJS.
        * cpio.texi:  More changes for 2.4.

Wed Dec 14 16:14:27 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* copypass.h:  When given the -a option, set the access time of
	the copy to be the access time of the original (instead of the
	modification time of the original).  Reported by
	karney@pppl.gov (Charles Karney).
	* cpio.texi:  Updated with changes for 2.4.

Wed Nov  3 18:18:07 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* safe-stat.h, Makefile.in:  New file used by mkdir.c.  This will go
	away when we get the real safe-xstat.[ch]in for mkdir.c.
	* main.c:  Don't mention [--null] twice in -p's usage message.
	Changed --no-absolute-paths to --no-absolute-filenames.
	* cpio.1:  Updated man page with new features.
	* cpio.texi, texinfo.tex, Makefile.in:  Added texi documentation
	from Robert Carleton (rbc@gnu.ai.mit.edu).

Mon Oct  3 00:46:30 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* makefile.pc, system.h:  Changes to compile with Borland C++ 4.0.

Thu Sep 29 22:15:50 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* makepath.c: Don't #define index if it is already #defined.

	* mt.c:  Check for __hpux defined instead of __hpux__.  Reported
	by ericb@lsid.hp.com (Eric Backus).

Thu Sep 29 11:21:31 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* extern.h, util.c, copyout.c, copypass.c, main.c, global.c:
	Never mind --ignore-disk-input-errors flag, we'll just always
	do that, like tar.

	* global.c, extern.h, main.c, copyin.c, copyout.c, copypass.c:
	Added --quiet flag to supress printing number of blocks copied.

	* global.c, extern.h:  If compiled with gcc, make input_bytes
	and output_bytes `long long' instead of `long'.  We need more
	than 32 bits to keep track of the number of bytes copied to
	and from tape drives that hold more than 4Gbytes.

	* util.c, copyin.c, main.c, global.c, extern.h:  Added
	--only-verify-crc flag to read a CRC format archive and verify
	its contents' CRCs.

	* copyout.c:  Fixed problem with creating oldc format archives
	on machines with 16 bit ints.  Reported by mpoole@cix.compulink.co.uk
	(Martin Poole).

	* mt.c: Need to open tape WR_ONLY for erase command (and probably
	others?).  Reported by robert@hst.e.technik.uni-kl.de (Robert
	Vogelgesan).  Accept `eject' as a synonym for `offline'.  Accept
	`-t' as a synonym for `-f' (to be compatible with HPUX mt, which 
	only accepts `-t').

Wed Sep 28 12:01:55 1994  John Oleynick  (juo@wombat.gnu.ai.mit.edu)
	* extern.h, global.c, main.c, util.c: only write sparse files
	when given --sparse flag.
	* extern.h, util.c, copyout.c, copypass.c, main.c, global.c:
	Added support for --ignore-disk-input-errors flag.

Wed Aug 24 12:55:38 1994  David J. MacKenzie  (djm@churchy.gnu.ai.mit.edu)

	* configure.in: Replace calls to AC_REMOTE_TAPE and AC_RSH
	with equivalent code, since those macros are going away.

Sun Feb 13 00:56:48 1994  John Oleynick  (juo@goldman.gnu.ai.mit.edu)
	* extern.h, global.c, main.c, util.c:  Added code to 
	tape_buffered_peek() to properly handle large, corrutped 
	archives, without overrunning the allocated buffer and
	dumping core.  Also changed the way the input and output 
	buffers are allocated in initialize_buffers().
	
Tue Jan 25 01:04:32 1994  John Oleynick  (juo@goldman.gnu.ai.mit.edu)
	* copyin.c, copyout.c, copypass.c, extern.h, main.c, tar.c, util.c:
	Redid i/o buffer code.  Previously, the same routines buffered input and
	output for accessing the archive and the filesystem.  Now there are
	separate routines for buffering input and output and for buffering the
	archive and the filesystem.  This simplifies much of the buffer code
	(e.g., only input from the archive has to check for end of tape and
	allow the tape to be changed, only output to the filesystem has to
	handle byte and word swapping, etc.; previously one routine had to
	handle all of these special cases) This is how the routines got split
	and renamed (old name -> new name):

		clear_rest_of_block -> tape_clear_rest_of_block
		copy_files -> copy_files_tape_to_disk
		    "      -> copy_files_disk_to_disk
		    "      -> copy_files_disk_to_tape
		copy_buf_out -> disk_buffered_write
		    "        -> tape_buffered_write
		copy_in_buf -> tape_buffered_read
		empty_output_buffer -> tape_empty_output_buffer
		    "               -> disk_empty_output_buffer
		fill_input_buffer -> tape_fill_input_buffer
		    "             -> disk_fill_input_buffer
		pad_output -> tape_pad_output
		peek_in_buf -> tape_buffered_peek
		skip_padding -> tape_skip_padding
		toss_input -> tape_toss_input

	* extern.h, global.c, main.c, util.c:  Added support for
	writing sparse files.

Tue Dec 28 23:01:36 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)
	* util.c, system.h, makepath.c, extern.h: don't define chown() 
	and don't typedef uid_t and gid_t if we are being compiled
	by DJGPP.

	* copyin.c, extern.h, global.c, main.c:  Added support for
	--rename-batch-file.
	
	* copyin.c, copyout.c, extern.h:  Cleaned up to pass gcc -Wall.

Wed Dec 22 02:17:44 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* makepath.c, copypass.c, copyin.c:  If cpio was creating a
	directory that contained `.' in the pathname (e.g. `foo/./bar'),
	it would complain that it could not create `.', since it already
	exists.  From schwab@issan.informatik.uni-dortmund.de (Andreas
	Schwab).

	* mt.c:  Added "eject" as a synonym for "offline".

	* util.c:  Slight modification to when we lseek with
	BROKEN_LONG_TAPE_DRIVER (do it every 1Gb, instead 
	of every 2Gb).

	* copyin.c, global.c, extern.h:  Added --no-absolute-paths option, 
	to ignore absolute paths in archives.

Tue Dec 21 01:30:59 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* util.c:  Fix for copying new_media_message_after_number.  From
	Christian.Kuehnke@arbi.informatik.uni-oldenburg.de (Christian
	Kuehnke).

Thu Jul 29 20:35:57 1993  David J. MacKenzie  (djm@wookumz.gnu.ai.mit.edu)

	* Makefile.in (config.status): Run config.status --recheck, not
	configure, to get the right args passed.

Mon Jul 19 23:01:00 1993  David J. MacKenzie  (djm@churchy.gnu.ai.mit.edu)

	* Makefile.in (libdir): Use standard GNU value --
	$(exec_prefix)/lib, not /etc.
	(.c.o): Put CFLAGS last.

Thu Jul  8 19:43:39 1993  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* Makefile.in: Add rules for remaking Makefile, configure,
	config.status. 

Mon Jul  5 14:54:08 1993  John Oleynick  (juo@spiff.gnu.ai.mit.edu)

	* cpio.1:  Updated man page for 2.3.
	* Makefile.in:  Create distribution with .gz extension, instead of .z.

Tue Jun 29 18:54:37 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* Makefile.in: Added installdirs target (using mkinstalldirs).
	* Added mkinstalldirs script.
	* main.c, mt.c:  Added --help option.  Changed usage() to
	take a stream and exit value (so --help can print on stdout
	and return a 0 exit status).
	* extern.h:  Removed usage()'s prototype (it was out of date,
	and only used in main.c).

Thu May  6 00:22:22 1993  John Oleynick  (juo@hal.gnu.ai.mit.edu)

	* cpio.1:  Added hpbin and hpodc.

Tue May  4 00:32:29 1993  John Oleynick  (juo@hal.gnu.ai.mit.edu)

	* copyin.c (process_copy_in), copypass.c (process_copy_pass):  When
	deleting an existing file, if the file is a directory, use rmdir()
	instead of unlink().

Thu Apr 29 14:43:56 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* tar.c (read_in_tar_header):  Clear non-protection bits from
	mode, in case tar has left some device bits in there.

Wed Apr 28 10:36:53 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* util.c: Added code to try and work around broken tape drivers
	that have problems with tapes > 2Gb.

	* copyout.c (process_copy_out): Pass file_hdr to 
	writeout_other_defers() and add_link_defer() by reference, 
	not by value.

	* copyin.c (process_copy_in): Pass file_hdr to defer_copyin()
	and create_defered_links() by reference, not by value.

	* defer.c: include <sys/types.h> (to build on BSD 4.3 on HP300)

Fri Apr 16 18:01:17 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* mt.c, util.c: Include <sys/mtio.h> if HAVE_SYS_MTIO_H is 
	defined, not HAVE_MTIO_H.

Wed Apr 14 17:37:46 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* util.c: Include <sys/io/trioctl.h> if HAVE_SYS_IO_TRIOCTL_H
	is defined.

	* mt.c: Only include <sys/mtio.h> if HAVE_SYS_MTIO_H is defined.

Fri Apr  2 13:09:11 1993  John Oleynick  (juo@goldman.gnu.ai.mit.edu)

	* configure.in: Added fnmatch to AC_REPLACE_FUNCS.  Added
	sys/io/trioctl.h to AC_HAVE_HEADERS.

	* Makefile.in: Removed fnmatch.o from OBJS.

	* copyin.c: Only include "fnmatch.h" if FNM_PATHNAME isn't
	defined yet.

	* mt.c: Include <sys/io/trioctl.h> if HAVE_SYS_IO_TRIOCTL_H is
	defined.

Mon Mar 29 17:04:06 1993  John Oleynick  (juo@hal.gnu.ai.mit.edu)

	* Many changes for supporting HPUX Context Dependent Files;
	also some bug fixes to fix problems with multiply (hard) linked
	device files; minor changes to support HPUX format archives
	(slightly broken?) System V.4 posix tar archives and HPUX
	posix tar archives.

	* Makefile.in: New files defer.o, defer,c and defer.h; added
	-DSYMLINK_USES_UMASK and -DHPUX_CDF comments; changed dist rule
	to use gzip with tar, instead of compress.

	* copyin.c: changes for new arf_hpbinary and arf_hpascii formats;
	HPUX CDF's; DEBUG_CPIO; fixes to properly handle multiple
	links in newc and crc format archives (new routines defer_copyin(),
	create_defered_links(), create_final_defers()); move most
	multiple (hard) link code to new routines link_name() and
	link_to_maj_min_ino(); use new macro UMASKED_SYMLINK instead of
	symlink().

	* copyout.c: fixes to properly handle multiple links in newc
	and crc format archives (new routines last_link(), 
	count_defered_links_to_dev_ino(), add_link_defer(),
	writeout_other_defers(), writeout_final_defers(),
	writeout_defered_file()); support for new arf_hpbinary and
	arf_hpascii formats; support for HPUX CDF's.

	* copypass.c: move most multiple link code to new routines
	link_name() and link_to_maj_min_ino(); use new macro UMASKED_SYMLINK
	instead of symlink(); support for HPUX CDF's.

	* extern.h: added arf_hpascii and arf_hpbinary archive enum types;
	added debug_flag.

	* global.c: added debug_flag.

	* main.c: added debug_flag; support for hpodc and hpbin formats.

	* makepath.c: split from standard makpath.c to add support
	for HPUX CDF's.

	* mt.c: added !defined(__osf__) (from Andrew Marquis
	<amarquis@genome.wi.mit.edu>).

	* system.h: new macro UMASKED_SYMLINK

	* tar.c: minor changes to read (slightly broken?) System V.4 posix 
	tar archives and HPUX posix tar archives.

	* util.c: HPUX CDF support (including new routines
	add_cdf_double_slashes() and islasparentcdf()); new routine
	umasked_symlink().

Sun Mar 14 23:00:14 1993  Jim Meyering  (meyering@comco.com)

	* copypass.c (process_copy_pass): Use <=, not just <, when comparing
	mtimes.  From Pieter Bowman <bowman@math.utah.edu>.

Fri Jan 15 14:35:37 1993  David J. MacKenzie  (djm@kropotkin.gnu.ai.mit.edu)

	* copyin.c: Move include of fnmatch.h to get right FNM* macros.

Tue Nov 24 08:45:32 1992  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* Version 2.2.

	* copyout.c (process_copy_out): Add parens for gcc -Wall.
	From Jim Meyering.

	* system.h: Use HAVE_FCNTL_H, not USG.

	* dstring.c, mt.c, system.h: Use HAVE_STRING_H, not USG.

Fri Nov 20 22:47:18 1992  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* copyin.c (read_in_binary): Copy the dev and ino that are
	already in `file_hdr' into `short_hdr'.
	From dao@abars.att.com (David A Oshinsky).

	* system.h [!_POSIX_VERSION]: Declare lseek as off_t, not long.
	From Karl Berry.

Wed Oct 14 13:53:41 1992  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* Version 2.1.

Tue Oct 13 22:51:34 1992  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* main.c: Add --swap equivalent to -b.

	* mt.c: Add f_force_local variable and -V --version option.

Fri Oct  2 18:42:27 1992  David J. MacKenzie  (djm@kropotkin.gnu.ai.mit.edu)

	* main.c (long_opts, usage): Add --force-local option.

Thu Oct  1 23:23:43 1992  David J. MacKenzie  (djm@goldman.gnu.ai.mit.edu)

	* main.c (process_args) [__MSDOS__]: Don't call geteuid.

	* copyin.c (read_in_{old,new}_ascii): Use `l' for sscanf into longs.
	* copyout.c (write_out_header): Ditto for sprintf.
	* global.c, extern.h: Make input_size and output_size long.

Thu Sep 10 23:39:30 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* global.c, extern.h: Add new var f_force_local to work with
	rmt.h change from tar.

Sun Aug 23 00:18:20 1992  David J. MacKenzie  (djm@churchy.gnu.ai.mit.edu)

	* Version 2.0.

	* tar.c (otoa): Compute value in an unsigned long, not an int.
	* copyout.c (write_out_header) [__MSDOS__]: Don't use dev_t.

	* main.c (process_args): By default, don't chown for non-root users.

Sat Aug 22 14:17:54 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* global.c, extern.h: Use uid_t and gid_t.

	* main.c (main) [__EMX__]: Expand wildcards.
	* system.h [__EMX__]: Alias some error names.  From Kai Uwe Rommel.

	* extern.h [__STDC__]: Use prototypes.

	* copyin.c (process_copy_in), copyout.c (process_copy_out),
	copypass.c (process_copy_pass): Open all files with O_BINARY.
	Add cast to chmod call.
	* util.c: Add cast to bcopy calls.  Make hash_insert static.
	From Kai Uwe Rommel.

Thu Aug 20 22:03:49 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* util.c (peek_in_buf): Don't print "end of file" before
	getting the next reel of medium.

	* copyin.c (read_in_old_ascii): Allocate space for NUL terminator.
	Print newline for dot line when done, even if appending.

Thu Jul 23 16:34:53 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* tar.c (write_out_tar_header, read_in_tar_header)
	[__MSDOS__]: Don't try to get user and group names.
	* extern.h: Don't declare the functions to do it (need uid_t).

	* main.c [__MSDOS__]: Ignore the -R option.

	* system.h: Define makedev if defining major and minor.

	* copyin.c, copyout.c [__MSDOS__]: setmode on archive_des, not
	0 and 1.

Sat Jul 18 14:30:55 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* tar.c, stripslash.c, userspec.c, cpiohdr.h, tar.h, tarhdr.h,
	system.h: New files.
	* Move portability stuff from various files to system.h.
	* cpio.h: Rename header structure and members, and add
	new structure for SVR4 format.
	* copyin.c, copyout.c: Use the new structure internally, the
	old one only for I/O in the old formats.
	* copyin.c (read_in_header): Recognize the new archive formats.
	(read_in_new_ascii, read_pattern_file, skip_padding): New functions.
	(swab_array): Do the swapping using char pointers instead of
	bitwise arithmetic.
	(process_copy_in): Handle byte and halfword swapping and new formats.
	Ok if a directory we want to make already exists, but set its perms.
	Do chmod after chown to fix any set[ug]id bits.
	Use `struct utimbuf' instead of a long array.
	* copyout.c (write_out_header): Handle new formats.
	(process_copy_out): Use `struct utimbuf'.
	Handle appending and new formats.
	Remove any leading `./' from filenames.
	(read_for_checksum, clear_rest_of_block, pad_output): New functions.
	* copypass.c (process_copy_pass): Use `struct utimbuf'.
	Ok if a directory we want to make already exists, but set its perms.
	Do chmod after chown to fix any set[ug]id bits.
	Don't change perms of `.'.
	* extern.h, global.c: Replace the separate format flags with
	one variable.  Add new variables for the new options.
	* main.c: Add new options -A --append, -H --format, -C --io-size,
	-M --message, --no-preserve-owner, -R --owner, -E --pattern-file,
	-V --dot, -s --swap-bytes, -S --swap-halfwords, -b, -I, -k, -O.
	(usage): Document them.
	(process_args): Recognize them.  Use open_archive.
	(initialize_buffers): Allow room for tar archives and double buffers.
	* util.c (empty_output_buffer_swap): New function.
	(empty_output_buffer): Call it if swapping current file.
	Check additional end of media indicators.
	(swahw_array, peek_in_buf, prepare_append, open_archive,
	set_new_media_message): New functions.
	(fill_input_buffer): Don't print error message if end of media.
	(toss_input): Don't seek, always read.
	(copy_files): Update crc if needed.
	(find_inode_file, add_inode): Check major and minor numbers as
	well as dev.
	(get_next_reel): Prompt user if archive name is unknown.
	Print fancy messages.
	Close the archive and reopen it.

	Above primarily from John Oleynick <juo@klinzhai.rutgers.edu>.

	* util.c (find_inode_file): Use modulus when computing initial
	loop index.
	(add_inode): Zero out new entry.
	From scott@sctc.com (Scott Hammond).

	* cpio.h, copyin.c, copyout.c: Rename `struct cpio_header'
	members from h_foo to c_foo.

Wed May 20 00:09:26 1992  David J. MacKenzie  (djm@churchy.gnu.ai.mit.edu)

	* copyin.c:  If we include a header file specifically to get
	major et al., assume we have them.

Mon Mar  9 19:29:20 1992  David J. MacKenzie  (djm@nutrimat.gnu.ai.mit.edu)

	* mt.c (main): rmtclose the tape file descriptor.

	* main.c (main): rmtclose the archive, if not in copy-pass mode.

	* util.c (create_all_directories): Don't print a message when
	creating a directory, for UNIX compat.

	* copyin.c (process_copy_in), copypass.c (process_copy_pass):
	Skip file if it has the same timestamp as existing file, not just
	if it is older than existing file, for UNIX compat.

Tue Mar  3 12:06:58 1992  David J. MacKenzie  (djm@wookumz.gnu.ai.mit.edu)

	* main.c, mt.c (usage): Document long options as starting with
	-- instead of +.

	* extern.h: Only declare lseek if not _POSIX_VERSION.

Tue Dec 24 00:19:45 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* copyin.c: Use MAJOR_IN_MKDEV and MAJOR_IN_SYSMACROS instead
	of USG and _POSIX_VERSION to find major and minor macros.

	* mt.c: Use unistd.h and stdlib.h if available.

	* copyin.c, copyout.c, copypass.c, util.c, extern.h: Change
	POSIX ifdefs to HAVE_UNISTD_H and _POSIX_VERSION.

Sun Aug 25 06:31:08 1991  David J. MacKenzie  (djm at apple-gunkies)

	* Version 1.5.

	* bcopy.c: New file (moved from util.c).

	* mt.c (print_status): Not all hpux machines have mt_fileno
	and mt_blkno; rather than trying to track HP's product line,
	just assume none of them have them.

	* util.c (copy_buf_out, copy_in_buf): Use more efficient
	copying technique for a big speedup.

Fri Aug  2 04:06:45 1991  David J. MacKenzie  (djm at apple-gunkies)

	* configure: Support +srcdir.  Create config.status.
	Remove it and Makefile if interrupted while creating them.

Thu Jul 18 09:43:40 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* Many files: use __MSDOS__ instead of MSDOS.

	* util.c, configure: Use NO_MTIO instead of HAVE_MTIO, to keep
	up with tar and rtapelib.c.

Mon Jul 15 13:45:30 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* configure: Also look in sys/signal.h for signal decl.

Thu Jul 11 01:50:32 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* Version 1.4.

	* configure: Remove /etc and /usr/etc from PATH to avoid
	finding /etc/install.

Wed Jul 10 01:40:07 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* makefile.pc: Rewrite for Turbo C 2.0.
	* util.c [__TURBOC__] (utime): New function.
	* alloca.c, tcexparg.c: New files.

	* extern.h [STDC_HEADERS]: Don't declare malloc and realloc.

	* main.c [MSDOS]: Make binary mode the default.
	* copyin.c, copyout.c: Make stdin or stdout binary mode as
	appropriate (so cpio archives don't get corrupted).

	* Many files: Use <string.h> if STDC_HEADERS as well as if USG.

	* configure, Makefile.in: $(INSTALLPROG) -> $(INSTALL),
	$(INSTALLTEXT) -> $(INSTALLDATA).

Mon Jul  8 23:18:28 1991  David J. MacKenzie  (djm at wookumz.gnu.ai.mit.edu)

	* configure: For some library functions that might be missing,
	conditionally add the .o files to Makefile instead of
	defining func_MISSING.
	* mkdir.c: Renamed from mkrmdir.c.

Sat Jul  6 02:27:22 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* configure: echo messages to stdout, not stderr.
	Use a test program to see if alloca needs -lPW.

Thu Jun 27 16:15:15 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* copyin.c (process_copy_in), copyout.c (process_copy_out),
	copypass.c (process_copy_pass): Check close return value for
	delayed error notification because of NFS.

Thu Jun 20 02:43:33 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* configure: Include $DEFS when compiling test programs.

	* util.c: Only declare getpwuid and getgrgid if not POSIX.

	* Version 1.3.

	* copyin.c: Use time_t, not long, for time values.

	* mt.c (print_status): Special cases for HP-UX and Ultrix.

	* util.c: Compile bcopy if USG or STDC_HEADERS, not BCOPY_MISSING.

Tue Jun 11 16:40:02 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* copyin.c: Don't include sys/sysmacros.h if _POSIX_SOURCE.

	* copyin.c, copyout.c, copypass.c: Don't include sys/file.h if POSIX.

	* util.c: Include sys/types.h before, not after, pwd.h and grp.h.

	* configure: New shell script to aid configuration and create
	Makefile from Makefile.in.

	* copyin.c (process_copy_in): Use POSIX.2 fnmatch instead of
	glob_match. 

Mon Jun 10 22:11:19 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* global.c, extern.h: New variable, name_end.
	* main.c (process_args, usage): Add -0 +null option to set it.
	* copypass.c (process_copy_pass), copyout.c (process_copy_out): 
	Use it.

	* dstring.c (ds_fgetstr): New function made from ds_fgets.
	(ds_fgets, ds_fgetname): Implement as front ends to ds_fgetstr.

Sun Jun  2 15:45:24 1991  David J. MacKenzie  (djm at wheat-chex)

	* most files: use GPL version 2.

Sat May 18 11:39:22 1991  David J. MacKenzie  (djm at geech.gnu.ai.mit.edu)

	* copyin.c, copypass.c: Take out #ifdef MSDOS around chown.
	* util.c [MSDOS]: Provide dummy chown.

Fri May 17 21:29:05 1991  David J. MacKenzie  (djm at churchy.gnu.ai.mit.edu)

	* Version 1.2.

	* makefile.pc, cpio.cs: Update for new source and object files.

Fri Mar 15 05:48:36 1991  David J. MacKenzie  (djm at geech.ai.mit.edu)

	* global.c, extern.h: New variable `archive_desc'.
	* main.c (process_args): Set it.
	* copyout.c (process_copy_out), copyin.c (process_copy_in):
	Use it.

	* copyout.c (process_copy_out), copyin.c (process_copy_in):
	Remote tapes are special and not seekable; don't fstat them.

	* main.c (main, usage): Add -F, +file option.  Use rmtopen.
	(main): Exit after printing version number.
	* util.c (empty_output_buffer): Use rmtwrite instead of write.
	(fill_input_buffer): Use rmtread instead of read.
	(tape_offline): Use rmtioctl instead of ioctl.
	Test HAVE_MTIO instead of MTIO_MISSING, for tar compatibility.

Thu Mar 14 17:49:57 1991  David J. MacKenzie  (djm at geech.ai.mit.edu)

	* util.c (create_all_directories): Use make_path to do the work.

Sat Jan 12 15:32:15 1991  David J. MacKenzie  (djm at geech.ai.mit.edu)

	* copyin.c, copyout.c, copypass.c, util.c: Only declare
	`errno' if not MSDOS.  Some Unix errno.h do, some don't . . . .

	* global.c, extern.h: Make `input_size' and `output_size'
	unsigned, for 16 bit machines.

	* copyin.c (print_name_with_quoting): All non-ctrl chars are
	printable on MS-DOS.

	* util.c (empty_output_buffer): Never make sparse files;
	can create unrunnable executables.
	* copyin.c, copyout.c, copypass.c: Callers changed.
	* util.c (finish_output_file): Function removed.

Tue Nov  6 15:47:16 1990  David J. MacKenzie  (djm at apple-gunkies)

	* copyin.c, util.c, extern.h: Rename copystring to xstrdup.

Mon Oct 29 02:24:41 1990  David J. MacKenzie  (djm at apple-gunkies)

	* util.c (empty_output_buffer): Only make sparse files if
	NO_SPARSE_FILES is undefined, to accomodate dumb kernels.

Wed Jul 25 18:48:35 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* util.c (getuser, getgroup): Make uid and gid unsigned short,
	not int.

Sat Jul 21 00:44:44 1990  David J. MacKenzie  (djm at apple-gunkies)

	* copyin.c, copyout.c, copypass.c, util.c, cpio.h: Add ifdefs
	for MSDOS.

Sun Jul 15 23:51:48 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* copyin.c, copyout.c, copypass.c, global.c, extern.h, util.c:
	Use longs where appropriate, for 16 bit machines.

Sun Jul  8 22:58:06 1990  David J. MacKenzie  (djm at apple-gunkies)

	* main.c (process_args, usage): Change -b option to -O (old), to
	allow adding byte swapping later.

Sat Jul  7 14:48:35 1990  David J. MacKenzie  (dave at edfmd)

	* Version 1.1.

	* cpio.h: Make `mtime' and `filesize' unsigned long.
	* copyin.c (read_in_binary), copyout.c (write_out_header):
	High short-word of `mtime' and `filesize' always comes first.

	* (read_in_ascii, read_in_binary): New functions, from code in
	read_in_header. 
	(read_in_header): Search for valid magic number, then fill in
	rest of header using read_in_ascii and read_in_binary.
	* global.c, extern.h: New variable, `binary_flag'.
	* main.c (process_args): Recognize new -b +binary option.
	* util.c [BCOPY_MISSING] (bcopy): New function.

Wed Jul  4 00:40:58 1990  David J. MacKenzie  (djm at apple-gunkies)

	* main.c (process_args): Add local pointers to functions to
	work around a pcc bug found on a Convex.

	* copyin.c (process_copy_in), util.c (toss_input,
	create_all_directories, add_inode): Don't use `index' as a
	variable name. 

Tue Jul  3 02:33:36 1990  David J. MacKenzie  (djm at apple-gunkies)

	* version 1.0.

Mon Jul  2 23:18:56 1990  David J. MacKenzie  (djm at twiddle)

	* copyin.c (process_copy_in), copyout.c (process_copy_out),
	copypass.c (process_copy_pass): Print "1 block", not "1 blocks".

	* copyin.c (process_copy_in), copypass.c (process_copy_pass):
	Unlink existing dest. file unless either it is newer and
	not unconditional, or it is a directory.

Mon Jul  2 03:57:41 1990  David J. MacKenzie  (dave at edfmd)

	* util.c (xrealloc): New function.
	* dstring.c (ds_resize): Use xrealloc instead of free and
	xmalloc.  Never shrink the string.

	* copypass.c (process_copy_pass): More efficient
	string handling while constructing output filename.

	* global.c, extern.h, main.c, cpio.h: Change from an enum,
	`copy_command', to a pointer to a void function, `copy_function'.

	* cpio.h (struct cpio_header): Make most fields unsigned.
	Rename h_filesize to h_filesizes and h_mtime to h_mtimes, and
	add new `long' fields with the old names at the end of the
	structure.
	* copyin.c (read_in_header): Set the long fields from the
	short arrays, making sure longs are aligned properly.
	(process_copy_in, long_format): Use the long fields.
	* copyout.c (write_out_header): Set the short arrays from the
	long fields, making sure longs are aligned properly.
	(process_copy_out): Use the long fields.

	* global.c, extern.h: New variable `output_is_seekable'.
	* util.c (empty_output_buffer): If output_is_seekable, use
	lseek to write blocks of zeros.
	(finish_output_file): New function.
	* copyin.c (process_copy_in), copyout.c (process_copy_out),
	copypass.c (process_copy_pass): Set `output_is_seekable'
	correctly and call finish_output_file.
	* main.c (initialize_buffers): Allocate space for sentinel in
	`output_buffer'. 

	* global.c, extern.h: New variable `numeric_uid'.
	* main.c (process_args): Accept -n +numeric-uid-gid option, like ls.
	* copyin.c (long_format): Use numeric_uid.

	* copyin.c (process_copy_in), copyout.c (process_copy_out),
	copypass.c (process_copy_pass): Don't (for verbose) print the
	names of files that are not copied because of errors.  Try to
	create missing directories for all file types.  Free temporary
	buffers on error.

Sat Jun 30 14:28:45 1990  David J. MacKenzie  (djm at apple-gunkies)

	* version.c: New file.
	* main.c: Add -V, +version option.
	* Makefile [dist]: Extract version number from version.c.

Sat Jun 30 12:44:47 1990  David J. MacKenzie  (dave at edfmd)

	* global.c, extern.h, copyin.c, copyout.c, util.c: Rename
	`{input,output}_is_regular' to `{input,output}_is_special' and
	reverse the truth value. 

	* global.c, extern.h: New variable `input_is_seekable' to
	control whether to skip data with lseek or read. 
	* copyin.c (process_copy_in): Set it.
	* util.c (toss_input): Use it.

	* global.c, extern.h: New variable `xstat' that selects stat
	or lstat for input files.
	* main.c (process_args): New option -L, +dereference to set
	xstat to stat instead of lstat.
	(usage): Document it.
	* copyout.c (process_copy_out), copypass.c
	(process_copy_pass): Use *xstat on input file.

Sat Jun 30 01:53:12 1990  David J. MacKenzie  (dave at edfmd)

	* dstring.c (ds_init): Return void because return value was
	never used. 
	(ds_resize): Ditto, and free old value instead of new one.

	* util.c (empty_output_buffer, fill_input_buffer,
	copy_out_buf, copy_in_buf, toss_input, copy_files): Return
	void instead of an error value and make errors fatal
	immediately instead of several levels up, to prevent printing
	of multiple error messages by different levels of functions.

	* copyin.c (read_in_header): Return void, because the error
	handling all happens at lower levels.
	(print_name_with_quoting): New function.
	(long_format): Call print_name_with_quoting.  Take additional
	arg for name of linked-to file, and print it if nonzero.
	(process_copy_in): For verbose listing of symlinks, read in
	the linkname and pass it to long_format.

	* extern.h: Declare some more functions.

Thu Jun 28 16:07:15 1990  David J. MacKenzie  (dave at edfmd)

	* copypass.c (process_copy_pass): Warn about unknown file types.

	* copyout.c (process_copy_out): Check fstat return for error.
	Record filesize of 0 for special files.  Warn about unknown
	file types.

	* copyin.c (process_copy_in): Warn about unknown file types.
	(read_in_header): Warn about byte-reversed binary headers.

Sat Jun 23 22:50:45 1990  David J. MacKenzie  (dave at edfmd)

	* main.c (main): Set umask to 0 so permissions of created
	files are preserved. 

	* copyin.c, copyout.c, copypass.c, util.c: Pass file
	descriptors as ints, not pointers to ints. 
	Cast file timestamps and sizes to long *, not int *, for 16
	bit machines.
	Use lstat instead of stat, if available.
	Handle FIFO's, sockets, and symlinks, if supported by O.S.

	* copyin.c (process_copy_in), copyout.c (process_copy_out):
	Don't consider FIFO'S, sockets, etc. to be possible tape drives.

	* util.c (create_all_directories): Fix incorrect loop
	termination check.  Only copy string if it contains slashes.
	Don't check whether directory "" exists.
	(tape_offline): Code moved from get_next_reel.
	(get_next_reel): Print message before taking tape offline.
	Read a line of arbitrary length.

	* copyout.c, copyin.c, copypass.c: Always use utime, not utimes.

	* copyin.c (swab_short): New macro.
	(swab_array): New function.
	(read_in_header): In binary mode, if a byte-swapped header is
	read, swap the bytes back.
	(process_copy_in, process_copy_pass): Don't stat each file to
	create unless !unconditional_flag.  Create device files correctly.
	Don't temporarily allow files being created to be read by
	other users.  Don't unnecessarily chmod special files.

Thu May 31 20:51:43 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* copyin.c (long_format): Use mode_string to format
	file protections instead of doing it ourselves.
	(protections): Function removed.

Sat Apr 14 02:31:01 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* cpio.h (struct cpio_header): Make inode, mode, uid, gid
	fields unsigned. 

	* util.c (getgroup): New function.
	* copyin.c (long_format): Print group name of files.
	Print file size, etc. as unsigned integers, not signed.

	* main.c (process_args): If -t is given and neither -i, -o, or
	-p is given, assume -i.

	* Add -f, +nonmatching option.
	* main.c: Rename +out to +create, +in to +extract,
	+modification-time to +preserve-modification-time,
	+pass to +pass-through.

	* copyin.c (process_copy_in), copypass.c (process_copy_pass):
	Don't complain in chown fails because the user doesn't have
	permission. 

Fri Apr 13 13:53:20 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* Add ifdefs for USG/Xenix.
	* util.c (cpio_error): Function removed.
	* Use error instead of cpio_error, so system error messages
	will be included.
	* cpio.h: Rename 'hdr_struct' to 'struct cpio_header'.
	* Move definition of xmalloc from dstring.c to util.c.
	* global.c, extern.c: Add global `program_name'.
	* main.c (main): Set program_name.
	(process_args): Rename +reset-atime to +reset-access-time,
	+table to +list.
	Have +block-size take an argument.

Thu Apr 12 13:33:32 1990  David J. MacKenzie  (djm at rice-chex)

	* util.c (find_inode_file): Make inode an int, not a short.

	* Make functions that don't return a value have type void.
	Add some casts to function calls.

Wed Apr 11 14:55:28 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* main.c (process_args): -i, -o, and -p don't take arguments.

	* main.c (process_args): Get the non-option args from the
	correct elements of argv.

Tue Apr 10 00:20:26 1990  David J. MacKenzie  (djm at albert.ai.mit.edu)

	* Indent source code and update copyrights.

	* cpio.c (usage): Change `collection' to `archive' in message.

Thu Dec 28 03:03:55 1989  David J. MacKenzie  (djm at hobbes.ai.mit.edu)

	* dstring.c (xmalloc): Don't return a null pointer if size is 0,
	on the assumption that trying to allocate 0 bytes is a bug that
	should be trapped.

Wed Dec 20 03:24:48 1989  David J. MacKenzie  (djm at hobbes.ai.mit.edu)

	* All files: Change from GNU CPIO General Public License to
	GNU General Public License.

Mon Dec 18 13:18:36 1989  David J. MacKenzie  (djm at hobbes.ai.mit.edu)

	* Makefile: Add clean target and defines for CC and LDFLAGS.
	Add dist target and SRCS, DISTFILES macros.  Add tags and TAGS targets.
	* dstring.c (ds_fgets): Read characters into an int, not char.
	(xmalloc): New function.
	(out_of_memory): Function removed.
	Global: use xmalloc instead of malloc and out_of_memory.
	* extern.h, global.c: Make flag variables ints instead of chars for
	compatibility with getopt_long.
	* extern.h: Declare more functions.
	* main.c (usage): Put the whole usage message into a single string
	and fix errors.
	* util.c (create_all_directories): Remove unused variable.
	(get_next_reel): Ditto.
	* dstring.h: Declare function.

Sat Dec  2 13:22:37 1989  David J. MacKenzie  (djm at hobbes.ai.mit.edu)

	* main.c: Change +copy-pass option to +pass, +copy-in to +in,
	+copy-out to +out, and +mkdir to +make-directories, and add null
	option to terminate table.
	(process_args): Use the same code to handle long and short named 
	options.
	(usage): Mention long options in message.

Local Variables:
mode: change-log
version-control: never
buffer-read-only: t
End:
